/*
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const MtgApp = require('./MtgApp')
const DataOutputStream = require('./entreesSorties/DataOutputStream')
const Dimf = require('types/Dimf')
module.exports = MtgApp

// Ce fichier contient des fonctions uniquement utiles pour la version electron

/**
 * Fonction utilisée par electron et renvoyant un tableau d'entiers contenant le code binaire de la figure
 * @returns {Array|*}
 */
MtgApp.prototype.getByteArrayCode = function () {
  var oups = new DataOutputStream()
  // Si un cadre a été choisi dans la figure et si la case à cocher est cochée, on enregistre la figure
  // avec les dimensions du cadre
  var doc = this.doc
  var olddimf = this.dimf
  var avecCadre = (this.cadre !== null)
  if (avecCadre) doc.dimf = new Dimf(this.widthCadre, this.heightCadre)
  doc.write(oups)
  doc.dimf = olddimf
  return oups.ba
}
