/*
 * Created by yvesb on 18/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const AvertDlg = require('./AvertDlg')
const $ = require('./../global/jQuery-ui')
module.exports = AddConstDlg

function AddConstDlg (app) {
  MtgDlg.call(this, app, 'AddConstDlg')
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  this.input = kernel.ce('input', {
    type: 'file',
    id: 'file',
    accept: '.mgc',
    class: 'inputfile'
  })
  var self = this
  this.input.addEventListener('change', function () {
    if (self.input.files.length > 0) $('#labelinf').html(' ' + self.input.files[0].name)
    else $('#labelinf').html('')
  })
  tr.appendChild(this.input)
  var label = kernel.ce('label', {
    for: 'file'
  })
  $(label).html(kernel.getStr('Parcourir'))
  tr.appendChild(label)
  // Un label à droite pour contenir le chemin d'accès du fichier choisi
  var labelinf = kernel.ce('label', {
    id: 'labelinf',
    style: 'margin-left: 10px;'
  })
  tr.appendChild(labelinf)

  this.create('AddConst', 500)
  $(this.input).blur()
}

AddConstDlg.prototype = new MtgDlg()

AddConstDlg.prototype.OK = function () {
  var app = this.app
  var file = this.input.files[0]
  if (file) {
    app.addProtoFromFile(file)
    this.destroy()
  } else new AvertDlg(app, 'FichierErr')
}
