/*
 * Created by yvesb on 30/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('./../global/jQuery-ui')

module.exports = AvertDlg

function AvertDlg (app, message, callBackOK = null) {
  // Il peut arriver que quand on appuie deux fois très rapidement sur entrée en validant un input
  // d'une boîte de dialogue alosr qu'on a redonné le focus à l'input après une erreur qu'un deuxième
  // dialogue d'avertissment soit lancé alors que le premier est déjà présent
  // D'où la ligne suivante
  if (app.lastDlgId() === 'avertDlg') return
  MtgDlg.call(this, app, 'avertDlg', callBackOK)
  this.callBackOK = callBackOK
  var label = kernel.ce('label')
  // Si le message n'est pas défini, c'est un message composé
  var mes = kernel.getStr(message)
  if (mes === '') mes = message
  $(label).html(mes)
  this.appendChild(label)
  var self = this
  $('#' + self.id).dialog({
    modal: true,
    title: kernel.getStr('Avert'),
    buttons: [{
      text: kernel.getStr('Fermer'),
      id: 'btnClose',
      click: function () {
        self.OK()
      }
    }],
    open: function () {
      self.onOpen()
    },
    closeOnEscape: false,
    width: 500,
    // On centre la boîte de dialogue sur le div parent de l'application
    position: { my: 'center', at: 'center', of: '#divMtgDlg' }
  })
}

AvertDlg.prototype = new MtgDlg()

AvertDlg.prototype.onOpen = function () {
  setTimeout(function () { // Ne marche pas sans un setTimeOut
    $('#btnClose').focus() // Pour que le focus soit donné au bouton Fermer
  }, 100)
}

AvertDlg.prototype.OK = function () {
  var self = this
  // if (time - self.timeStart < MtgDlg.delay) return; // Moins d'une seconde dans doute mauvais endroit de clic sur un bouton
  this.destroy()
  if (this.callBackOK !== null) {
    setTimeout(function () {
      self.callBackOK()
    }, 500)
  }
  // A noter que sur ipad l'utilisation de setTimeOut fait que le clavier ne réapparait pas.
  // Mais si on supprime le setTimeOut, le clavier apparaît mais le champ d'édition peut être caché par le clavier...
}
