/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const kernelAdd = require('../kernel/kernelAdd')
const MtgDlg = require('./MtgDlg')
const $ = require('jquery')

module.exports = ChoixAngleUsuelDlg

function ChoixAngleUsuelDlg (app, input, angleUnity) {
  MtgDlg.call(this, app, 'ChoixAngDlg')
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var tab = angleUnity === kernel.uniteAngle.degre ? kernelAdd.listeAngleDeg : kernelAdd.listeAngleRad
  this.select = kernel.ce('select', {
    size: 8,
    style: 'width:120px'
  })
  tr.appendChild(this.select)
  var self = this
  for (var i = 0; i < tab.length; i++) {
    var option = kernel.ce('option', {
      class: 'mtgOption'
    })
    $(option).html(tab[i])
    option.onclick = function () {
      $(input).val(tab[self.select.selectedIndex])
      self.destroy()
    }
    this.select.appendChild(option)
  }
  // Attention : Pour cette boîte de dialogue ne pas appeler create
  var buttons = {}
  buttons[kernel.getStr('Fermer')] = function (ev) {
    self.onClose(ev)
  }
  // Cette boîte de dialogue n'a qu'un bouton : On n'appelle pas create
  $('#' + self.id).dialog({
    modal: true,
    title: kernel.getStr('AngUs'),
    buttons: buttons,
    width: 200,
    closeOnEscape: false,
    position: { my: 'center', at: 'center', of: '#divMtgDlg' }
  })
}

ChoixAngleUsuelDlg.prototype = new MtgDlg()
