/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('./../global/jQuery-ui')

module.exports = ChoixEltsFigesDlg

function ChoixEltsFigesDlg (app) {
  MtgDlg.call(this, app, 'ChoixEltsFigesDlg')
  var doc = app.doc
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var div = kernel.ce('div')
  tr.appendChild(div)
  var input = kernel.ce('input', {
    id: 'cb1',
    type: 'checkbox'
  })
  div.appendChild(input)
  if (doc.affichagesFiges) $(input).attr('checked', 'checked')
  var label = kernel.ce('label', {
    for: 'cb1'
  })
  div.appendChild(label)
  $(label).html(kernel.getStr('affFiges'))

  tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  div = kernel.ce('div')
  tr.appendChild(div)
  input = kernel.ce('input', {
    id: 'cb2',
    type: 'checkbox'
  })
  div.appendChild(input)
  if (doc.marquesAnglesFigees) $(input).attr('checked', 'checked')
  label = kernel.ce('label', {
    for: 'cb2'
  })
  $(label).html(kernel.getStr('marAngFigees'))
  div.appendChild(label)

  // Création de la boîte de dialogue par jqueryui
  this.create('EltsFiges', 500)
}

ChoixEltsFigesDlg.prototype = new MtgDlg()

ChoixEltsFigesDlg.prototype.OK = function () {
  var doc = this.app.doc
  doc.affichagesFiges = $('#cb1').prop('checked')
  doc.marquesAnglesFigees = $('#cb2').prop('checked')
  this.destroy()
}
