/*
 * Created by yvesb on 02/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const AvertDlg = require('../dialogs/AvertDlg')
const $ = require('jquery')
module.exports = EditeurNomCalcul

/**
 * Objet associé à un input d'une boîte de dialogue et chargé de regarder si
 * la syntaxe du contenu de l'éditeur est correcte pour un nom de calcul ou de fonction.
 * @param app L'application mtgApp propriétaire
 * @param bVerif Si true, doit vérifier que la liste ne contient pas déjà un calcul de même nom
 * @param input Le input associé
 * @constructor
 */

function EditeurNomCalcul (app, bVerif, input) {
  this.app = app
  this.bVerif = bVerif
  this.input = input
}

EditeurNomCalcul.prototype.validate = function () {
  var ch = $(this.input).val()
  var res = this.app.listePr.validationNomVariableOuCalcul(ch)
  if (this.bVerif) res = res && this.app.listePr.validationNomCalculSansMessage(ch)
  if (!res) {
    var self = this
    new AvertDlg(this.app, 'NomInvalide', function () {
      self.input.focus()
      // Test ligne suivante des fois que j'aie oublié de déclarer un éditeur comme MtgInput
      if (self.input.marquePourErreur) self.input.marquePourErreur()
    })
  }
  return res
}
