/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const $ = require('jquery')
const kernel = require('../kernel/kernel')
const ListeMacros = require('./ListeMacros')

module.exports = ListeConstFig

function ListeConstFig (app, callBackOnChange = null) {
  this.app = app
  var i
  var tablePrototypes = app.doc.tablePrototypes
  var nbConst = tablePrototypes.length
  this.int = []
  this.pointeurs = []
  this.select = kernel.ce('select', {
    size: 4, // Le nombre de lignes visibles par défaut
    style: 'width:250px'
  })

  for (i = 0; i < nbConst; i++) {
    var proto = tablePrototypes[i]
    this.pointeurs.push(proto)
    this.int.push(proto.nom)
    var option = kernel.ce('option', {
      class: 'mtgOption'
    })
    $(option).html(proto.nom)
    this.select.appendChild(option)
  }
  if (callBackOnChange) this.select.onchange = callBackOnChange
}

ListeConstFig.prototype = new ListeMacros()
