/*
 * Created by yvesb on 04/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const $ = require('./../global/jQuery-ui')

module.exports = MtgInput

function MtgInput (arg) {
  var argt = arguments.length === 0 ? {} : arguments[0]
  argt.type = 'text'
  var inp = kernel.ce('input', argt)
  inp.isRed = false
  inp.onblur = function () {
    if (inp.isRed) $(inp).css('background-color', '#FFFFFF')
  }
  inp.marquePourErreur = function () {
    $(inp).css('background-color', '#F5a9BC')
    inp.isRed = true
  }
  inp.demarquePourErreur = function () {
    if (inp.isRed) $(inp).css('background-color', '#FFFFFF')
    inp.isRed = false
  }
  inp.onkeyup = function () {
    if (inp.isRed) $(inp).css('background-color', '#FFFFFF')
    inp.isRed = false
  }
  // this.input = inp;
  return inp
}

/*
MtgInput.prototype.marquePourErreur = function() {
  $(this.input).css("background-color", "#FF9999");
}
  */
