/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const CarSpeciauxDlg = require('../dialogs/CarSpeciauxDlg')
const $ = require('jquery')
require('jquery-textrange')

module.exports = MtgTextAreaWithCharSpe

function MtgTextAreaWithCharSpe (app, arg, types, bLatex, dlg) {
  this.app = app
  this.dlg = dlg
  var self = this
  var argt = arguments.length === 1 ? {} : arguments[1]
  this.dlgCharSpe = null // Utilisé par les MtgInputWithCharSpe et CarSpeciauxDlg
  var inp = kernel.ce('textarea', argt)
  inp.onfocus = function () {
    if (self.dlg.dlgCharSpe === null) {
      self.dlg.dlgCharSpe = new CarSpeciauxDlg(app, this, types, bLatex, dlg, false)
      setTimeout(function () { // Ne marche pas sans un setTimeOut
        inp.focus() // Pour que le focus soit donné à l'éditeur au départ ou quand un  message d'erreur est affiché
      }, 100)
    }
  }
  // Si on appuie sur la touche tab on met le curseur dans la prochaine accolade ouvrante
  inp.onkeydown = function (ev) {
    if (ev.keyCode === 9) { // Touche Tab
      var select = $(this)
      var cp = select.textrange('get', 'start')
      var ch = select.val()
      var len = ch.length
      for (var i = cp; (i < len) && (ch.charAt(i) !== '{'); i++);
      if (i < len) select.textrange('setcursor', i + 1)
      else {
        var ind = ch.indexOf('}', cp)
        if (ind !== -1) select.textrange('setcursor', ind + 1)
      }
      kernel.preventDefault(ev)
    }
  }

  inp.onblur = function (ev) {
    // Les boutons servant à insérer les caractères sont de classe Carbutton.
    // Quand on clique sur un bouton, l'éditeur perd le focus masi la boîte de dialogue contenant
    // les boutons de doit pas se refermer
    if ((self.dlg.dlgCharSpe !== null) && (ev.relatedTarget !== null) && (!ev.relatedTarget || (
      (ev.relatedTarget.className !== 'charbutton') && (ev.relatedTarget.className !== 'charselect') &&
        (ev.relatedTarget.className.indexOf('ui-') !== 0)))) {
      self.dlg.dlgCharSpe.destroy()
      self.dlg.dlgCharSpe = null
    }
  }
  return inp
}
