/*
 * Created by yvesb on 14/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('jquery')
module.exports = OutilAddByListDlg

/**
 * Boîte de dialogue qui apparaît quand on clique sur une icône + située à droite de certaines
 * barres d'outils déroulables et présentant un liste d'outils. Utilisé pour la création de macros.
 * @param app L'application propriétaire
 * @param outilAdd du type OutilAdd
 * @param {string} title Le titre de la boîte de dialogue
 * @constructor
 */
function OutilAddByListDlg (app, outilAdd, title) {
  MtgDlg.call(this, app, 'OutilAddByListDlg')
  var self = this
  this.tools = []
  this.outilAdd = outilAdd
  var tab = kernel.ce('table')
  this.appendChild(tab)
  var tr = kernel.ce('tr')
  tab.appendChild(tr)
  this.select = kernel.ce('select', {
    size: 10, // Le nombre de lignes visibles par défaut
    style: 'width:400px'
  })
  tr.appendChild(this.select)
  var arr = outilAdd.toolArray
  var k = 0
  for (var i = 0; i < arr.length; i++) {
    var tool = app['outil' + arr[i]]
    if (tool.activationValide() && app.doc.toolDispo(tool.toolIndex) && app.level.toolDispo(tool.toolIndex)) {
      var option = kernel.ce('Option')
      this.tools.push(tool)
      if (k === 0) option.setAttribute('selected', 'selected')
      $(option).html(kernel.getStr(arr[i]))
      option.ondblclick = function () { self.OK() }
      this.select.appendChild(option)
      k++
    }
  }
  this.create(title, 500)
}

OutilAddByListDlg.prototype = new MtgDlg()

OutilAddByListDlg.prototype.OK = function () {
  this.tools[this.select.selectedIndex].select()
  this.destroy()
}
