/*
 * Created by yvesb on 29/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('./../global/jQuery-ui')
const AvertDlg = require('./AvertDlg')
module.exports = PolygoneRegDlg

function PolygoneRegDlg (app, nbSommets, callBackOK, callBackCancel) {
  MtgDlg.call(this, app, 'LieuDlg', callBackOK, callBackCancel)
  this.nbSommets = nbSommets
  var self = this
  var tab = kernel.ce('table')
  this.appendChild(tab)
  var tr = kernel.ce('tr')
  tab.appendChild(tr)
  var td = kernel.ce('td')
  tr.appendChild(td)
  var label = kernel.ce('label')
  $(label).html(kernel.getStr('NbSommets'))
  td.appendChild(label)
  td = kernel.ce('td')
  tr.appendChild(td)
  var input = kernel.ce('input', {
    id: 'mtginput',
    type: 'text'
  })
  input.size = 4
  td.appendChild(input)
  input.onkeyup = function (ev) {
    if (ev.keyCode === 13) {
      $(this).blur() // Nécéssaire sur ipad pour une raison que j'ignore
      self.OK()
    }
  }
  this.create('PolygoneReg', 450)
}

PolygoneRegDlg.prototype = new MtgDlg()

PolygoneRegDlg.prototype.onOpen = function () {
  MtgDlg.prototype.onOpen.call(this)
  setTimeout(function () { // Ne marche pas sans un setTimeOut
    $('#mtginput').focus() // Pour que le focus soit donné à l'éditeur au départ ou quand un  message d'erreur est affiché
  }, 100)
}

PolygoneRegDlg.prototype.OK = function () {
  var app = this.app
  var nbSommets = parseInt($('#mtginput').val())
  if (nbSommets < 4 || nbSommets > 100 || isNaN(nbSommets)) {
    new AvertDlg(app, 'Incorrect', function () {
      $('#mtgInput').focus()
    })
  } else {
    this.nbSommets.setValue(nbSommets)
    this.destroy()
    this.callBackOK()
  }
}
