/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('jquery')
const MtgTextAreaWithCharSpe = require('./MtgTextAreaWithCharSpe')
module.exports = TextFigDlg

function TextFigDlg (app) {
  MtgDlg.call(this, app, 'textdlg')
  var tabPrincipal = kernel.ce('table', {
    cellspacing: 10
  })
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  this.textarea = new MtgTextAreaWithCharSpe(app, { cols: 80, rows: 20, wrap: 'off' }, ['grec', 'math', 'arrows'], false, this)
  this.textarea.owner = this
  tr.appendChild(this.textarea)
  var jqta = $(this.textarea)
  jqta.css('overflow-x', 'scroll')
  // On ne peut pas utiliser de style css pour le textarea car sinon il est écrasé par un autre style de jquery
  jqta.css('font-size', '14px')
  jqta.val(app.doc.texteFigure)
  this.create('TextFig', 650)
}

TextFigDlg.prototype = new MtgDlg()

TextFigDlg.prototype.OK = function () {
  this.app.doc.texteFigure = $(this.textarea).val()
  this.destroy()
}
