/*
 * Created by yvesb on 22/02/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const LineStyleButtonForDlg = require('./LineStyleButtonForDlg')
const constantes = require('../kernel/constantes')
const kernel = require('../kernel/kernel')

module.exports = LineStylePanel

function LineStylePanel (app, styleinit) {
  this.app = app
  this.g = kernel.cens('g')
  this.lineStyleButtons = []
  var tabls = constantes.tableStyleTrait
  for (var i = 0; i < tabls.length; i++) {
    var c = tabls[i]
    this.lineStyleButtons.push(new LineStyleButtonForDlg(app, this, c[0], c[1], i))
  }
  this.style = styleinit // Style de trait continu
  this.select(styleinit)
}

LineStylePanel.prototype.select = function (style) {
  this.style = style
  var tab = this.lineStyleButtons
  for (var i = 0; i < tab.length; i++) {
    var btn = tab[i]
    var isActivated = btn.isActivated
    var isTarget = (btn.style === style)
    if (isTarget) {
      if (!isActivated) btn.activate(true)
    } else
    if (isActivated) btn.activate(false)
  }
}
