/*!
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 * Version 6.7.0
 */
import {
  create,
  addDependencies,
  multiplyDependencies,
  divideDependencies,
  invDependencies,
  matrixDependencies,
  detDependencies
} from 'mathjs'

const { add, multiply, divide, inv, matrix, det } = create({
  addDependencies,
  multiplyDependencies,
  divideDependencies,
  invDependencies,
  matrixDependencies,
  detDependencies
}, {})

const mathjs = {
  add: add,
  mult: multiply,
  div: divide,
  inv: inv,
  matrix: matrix,
  det: det
}

export default mathjs
