/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CAbscisseOrigineRep = require('../objets/CAbscisseOrigineRep')
const kernel = require('../kernel/kernel')
const CCalculAncetre = require('../objets/CCalculAncetre')
const InfoRepDlg = require('../dialogs/InfoRepDlg')
module.exports = CAbscisseOrigineRep

CAbscisseOrigineRep.prototype.infoHist = function () {
  var ch = this.nomCalcul + ' : ' + kernel.getStr('chinfo178') + ' ' + kernel.getStr('chinfo32') + ' ' + this.rep.getNom()
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + ' ' + kernel.chaineNombre(this.abscisseOrigine, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CAbscisseOrigineRep.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CAbscisseOrigineRep.prototype.modifDlg = function (app, callBack1, callBack2) {
  new InfoRepDlg(app, this, 0, true, callBack1, callBack2)
}

CAbscisseOrigineRep.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CCalculAncetre.prototype.depDe4Rec.call(this, p) || this.rep.depDe4Rec(p))
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CAbscisseOrigineRep.prototype.genereNom = function () {
  CAbscisseOrigineRep.ind++
  return kernel.getStr('rabsor') + CAbscisseOrigineRep.ind
}

CAbscisseOrigineRep.prototype.estDefiniParObjDs = function (listeOb) {
  return this.rep.estDefPar(listeOb)
}
