/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CArcDeCercleImage = require('../objets/CArcDeCercleImage')
const CArcDeCercleAncetre = require('../objets/CArcDeCercleAncetre')
const kernel = require('../kernel/kernel')
module.exports = CArcDeCercleImage

CArcDeCercleImage.prototype.antecedentDirect = function () {
  return this.transformation
}

CArcDeCercleImage.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo37') + ' ' + this.antecedent.nom + ' ' +
    kernel.getStr('par') + ' ' + this.transformation.complementInfo()
}

CArcDeCercleImage.prototype.distancePoint = function (xp, yp, masquage) {
  return this.arc.distancePoint(xp, yp, masquage)
}

CArcDeCercleImage.prototype.distancePointPourSurface = function (xp, yp, masquage) {
  return this.arc.distancePointPourSurface(xp, yp, masquage)
}

CArcDeCercleImage.prototype.modifiableParMenu = function () {
  return !this.estElementFinal && this.transformation.imageModifiableParMenu()
}

CArcDeCercleImage.prototype.contientParDefinition = function (po) {
  if (po.estPointImage()) {
    return (this.transformation === po.transformation) && (this.antecedent.contientParDefinition(po.antecedent))
  } else return true
}

CArcDeCercleImage.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CArcDeCercleAncetre.prototype.depDe4Rec.call(this, p) ||
    this.antecedent.depDe4Rec(p) || this.transformation.depDe4Rec(p))
}

CArcDeCercleImage.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  return this.arc.tikz(dimf, nomaff, coefmult, bu)
}

/**
 * Fonction qui renvoie true seulement pour les objets qui sont des objets images d'un autre par une transformation
 * @returns {boolean}
 */
CArcDeCercleImage.prototype.estImageParTrans = function () {
  return true
}

CArcDeCercleImage.prototype.estDefiniParObjDs = function (listeOb) {
  return this.antecedent.estDefPar(listeOb) &&
  this.transformation.estDefPar(listeOb)
}
