/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CBarycentre = require('../objets/CBarycentre')
const CPt = require('../objets/CPt')
const kernel = require('../kernel/kernel')
const ModificationBarycentreDlg = require('../dialogs/ModificationBarycentreDlg')
module.exports = CBarycentre

CBarycentre.prototype.infoHist = function () {
  var ch = this.nom + ' : ' + kernel.getStr('Barycentre') + ' ' + kernel.getStr('de') + ' '
  for (var i = 0; (i < this.col.length); i++) {
    var noeud = this.col[i]
    ch += '(' + noeud.pointAssocie.nom + ';' + noeud.poids.chaineInfo() + ') '
  }
  return ch
}

/**
 * Fonction renvoyant la somme des coefficients des points pondérés.
 * @returns {number}
 */
/*
CBarycentre.prototype.sommeCoefficients = function(){
  var resultat = 0;
  for (var i = 0; (i < this.col.length); i++) {
    var noeud = this.col[i];
    resultat = resultat + noeud.poids.rendValeur();
  }
  return resultat;
};
*/

CBarycentre.prototype.modifiableParMenu = function () {
  return false
}

CBarycentre.prototype.modifiableParProtocole = function () {
  return this.impProto === null
}

CBarycentre.prototype.modifDlg = function (app, callBack1, callBack2) {
  new ModificationBarycentreDlg(app, this, callBack1, callBack2)
}

CBarycentre.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  var resultat = false
  for (var i = 0; (i < this.col.length) && !resultat; i++) {
    var noeud = this.col[i]
    resultat = resultat || noeud.pointAssocie.depDe4Rec(p) || noeud.poids.depDe4Rec(p)
  }
  return this.memDep4Rec(resultat || CPt.prototype.depDe4Rec.call(this, p))
}

CBarycentre.prototype.estDefiniParObjDs = function (listeOb) {
  for (var i = 0; i < this.col.length; i++) {
    var noeud = this.col[i]
    // && noeud.pointAssocie.estDefiniParObjDs(listeOb) // Modifié version JS
    if (!(noeud.pointAssocie.estDefPar(listeOb) && noeud.poids.estDefiniParObjDs(listeOb))) return false
  }
  return true
}
