/*
 * Created by yvesb on 16/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CCommentaire = require('../objets/CCommentaire')
const CommentaireDlg = require('../dialogs/CommentaireDlg')
const CAffLiePt = require('../objets/CAffLiePt')
const kernel = require('../kernel/kernel')
const ModifAffFinalDlg = require('../dialogs/ModifAffFinalDlg')
module.exports = CCommentaire

CCommentaire.prototype.info = function () {
  return this.nom + ' : ' + kernel.getStr('Commentaire')
}
CCommentaire.prototype.infoHist = function () {
  var ch = this.info()
  if (this.pointLie !== null) ch += ' ' + kernel.getStr('liea') + ' ' + this.pointLie.nom
  return ch + this.infoAngle()
}

CCommentaire.prototype.modifiableParMenu = function () {
  return true
}

CCommentaire.prototype.modifDlg = function (app, callBack1, callBack2) {
  this.estElementFinal ? new ModifAffFinalDlg(app, this, callBack1, callBack2) : new CommentaireDlg(app, this, true, callBack1, callBack2)
}

CCommentaire.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CAffLiePt.prototype.depDe4Rec.call(this, p) ||
    this.listeValeursDynamiquesUtilisees.depDe4Rec(p))
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CCommentaire.prototype.genereNom = function () {
  CCommentaire.ind++
  return kernel.getStr('rcom') + CCommentaire.ind
}

CCommentaire.prototype.estDefiniParObjDs = function (listeOb) {
  return CAffLiePt.prototype.estDefiniParObjDs.call(this, listeOb) &&
    this.listeValeursDynamiquesUtilisees.estDefiniParObjDs(listeOb)
}
