/*
 * Created by yvesb on 12/01/2017.
 */

/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CDemiDroite = require('../objets/CDemiDroite')
const Point = require('../types/Point')
const kernel = require('../kernel/kernel')
const NatObj = require('../types/NatObj')
module.exports = CDemiDroite

CDemiDroite.prototype.distancePoint = function (xp, yp, masquage) {
  if (!(this.existe) || (masquage && this.masque)) return -1
  else {
    var pointr = new Point()
    kernel.projetteOrtho(xp, yp, this.point_x, this.point_y, this.vect, pointr)
    if (this.appartientA(pointr.x, pointr.y)) {
      return kernel.distancePointPoint(xp, yp, pointr.x, pointr.y)
    } else return -1
  }
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CDemiDroite.prototype.genereNom = function () {
  CDemiDroite.ind++
  return kernel.getStr('rdd') + CDemiDroite.ind
}

CDemiDroite.prototype.coincideAvec = function (p) {
  if (p.getNature() !== NatObj.NDemiDroite) return false
  return kernel.zero(this.point_x - p.point_x) && kernel.colineairesMemeSens(this.vect, p.vect)
}
