/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CDemiPlan = require('../objets/CDemiPlan')
const CSurface = require('../objets/CSurface')
const kernel = require('../kernel/kernel')
module.exports = CDemiPlan

CDemiPlan.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('DemiPlan') + ' ' + kernel.getStr('bord') + ' ' +
    this.bord.getNom() + ' ' + kernel.getStr('chinfo196') + ' ' + this.pointDemiPlan.nom
}

CDemiPlan.prototype.distancePoint = function (xp, yp, masquage) {
  if (!(this.existe) || (masquage && this.masque)) return -1
  else return this.bord.distancePointPourDemiPlan(xp, yp)
}

CDemiPlan.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CSurface.prototype.depDe4Rec.call(this, p) || this.pointDemiPlan.depDe4Rec(p))
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CDemiPlan.prototype.genereNom = function () {
  CDemiPlan.ind++
  return kernel.getStr('rdplan') + CDemiPlan.ind
}

CDemiPlan.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  var list = this.listeProprietaire
  var ch = '\\fill' + this.tikzFillStyle()
  var nbPtsBord = this.nbPtsBord
  for (var i = 0; i < nbPtsBord; i++) {
    ch += '(' + kernel.chaineNombre(list.tikzXcoord(this.absPtsBord[i], dimf, bu), 3) + ',' +
      kernel.chaineNombre(list.tikzYcoord(this.ordPtsBord[i], dimf, bu), 3)
    if (i < nbPtsBord - 1) ch += ')--'
    else ch += ')--cycle;'
  }
  return ch
}

CDemiPlan.prototype.estDefiniParObjDs = function (listeOb) {
  return CSurface.prototype.estDefiniParObjDs.call(this, listeOb) &&
  this.pointDemiPlan.estDefPar(listeOb)
}
