/*
 * Created by yvesb on 23/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CDroiteDirectionFixe = require('../objets/CDroiteDirectionFixe')
const CDroite = require('../objets/CDroite')
const kernel = require('../kernel/kernel')

module.exports = CDroiteDirectionFixe

CDroiteDirectionFixe.prototype.infoHist = function () {
  var ch = this.nom + ' : '
  if (this.droiteHorizontale) ch += kernel.getStr('chinfo50')
  else ch += kernel.getStr('chinfo51')
  ch += ' ' + kernel.getStr('chinfo196') + ' ' + this.a.nom
  return ch
}

CDroiteDirectionFixe.prototype.contientParDefinition = function (po) {
  return (this.a === po)
}

CDroiteDirectionFixe.prototype.estParalleleParDefinition = function (dte) {
  return (dte === this) ||
    ((dte.className === this.className) && (dte.droiteHorizontale = this.droiteHorizontale)) ||
    dte.estParalleleParDefinition(this)
}

CDroiteDirectionFixe.prototype.estPerpendiculaireParDefinition = function (dte) {
  return ((dte.className === this.className) && (dte.droiteHorizontale !== this.droiteHorizontale)) ||
  dte.estPerpendiculaireParDefinition(this)
}

CDroiteDirectionFixe.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CDroite.prototype.depDe4Rec.call(this, p) || this.a.depDe4Rec(p))
}

CDroiteDirectionFixe.prototype.adaptRes = function (coef) {
  CDroite.prototype.adaptRes.call(this, coef)
  this.longueurVecteur *= coef
  this.vect.x *= coef
  this.vect.y *= coef
}

CDroiteDirectionFixe.prototype.estDefiniParObjDs = function (listeOb) {
  return this.a.estDefPar(listeOb)
}
