/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CDroiteImage = require('../objets/CDroiteImage')
const CDroite = require('../objets/CDroite')
const CTransformation = require('../objets/CTransformation')
const kernel = require('../kernel/kernel')

module.exports = CDroiteImage

CDroiteImage.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo34') + ' ' + this.antecedent.getNom() + ' ' +
    kernel.getStr('par') + ' ' + this.transformation.complementInfo()
}

CDroiteImage.prototype.antecedentDirect = function () {
  return this.transformation
}

CDroiteImage.prototype.modifiableParMenu = function () {
  return !this.estElementFinal && this.transformation.imageModifiableParMenu()
}

CDroiteImage.prototype.contientParDefinition = function (po) {
  if (po.estPointImage()) {
    return (this.transformation === po.transformation) && po.antecedent.appartientDroiteParDefinition(this.antecedent)
  } else return false
}

CDroiteImage.prototype.estParalleleParDefinition = function (dte) {
  return (dte === this) ||
    (((this.transformation.natureTransformation() & CTransformation.tteTransImDtePar) !== 0) &&
    (this.antecedent.estParalleleParDefinition(dte) || dte.estParalleleParDefinition(this.antecedent)))
}

CDroiteImage.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CDroite.prototype.depDe4Rec.call(this, p) ||
    this.antecedent.depDe4Rec(p) || this.transformation.depDe4Rec(p))
}

/**
 * Fonction qui renvoie true seulement pour les objets qui sont des objets images d'un autre par une transformation
 * @returns {boolean}
 */
CDroiteImage.prototype.estImageParTrans = function () {
  return true
}

CDroiteImage.prototype.estDefiniParObjDs = function (listeOb) {
  return this.antecedent.estDefPar(listeOb) &&
  this.transformation.estDefPar(listeOb)
}
