/*
 * Created by yvesb on 16/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CDroiteOm = require('../objets/CDroiteOm')
const CoefDirDlg = require('../dialogs/CoefDirDlg')
const CDroite = require('../objets/CDroite')
const kernel = require('../kernel/kernel')

module.exports = CDroiteOm

CDroiteOm.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo152') + ' ' + this.m.chaineInfo() + ' ' +
    kernel.getStr('chinfo196') + ' ' + this.o.nom + ' ' + kernel.getStr('chinfo32') + ' ' + this.rep.getNom()
}

CDroiteOm.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CDroiteOm.prototype.modifDlg = function (app, callBack1, callBack2) {
  new CoefDirDlg(app, this, true, callBack1, callBack2)
}

CDroiteOm.prototype.contientParDefinition = function (po) {
  return (this.o === po)
}

CDroiteOm.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CDroite.prototype.depDe4Rec.call(this, p) ||
    this.o.depDe4Rec(p) || this.rep.depDe4Rec(p) || this.m.depDe4Rec(p))
}

CDroiteOm.prototype.estDefiniParObjDs = function (listeOb) {
  return this.rep.estDefPar(listeOb) &&
  this.o.estDefPar(listeOb) &&
  this.m.estDefiniParObjDs(listeOb)
}
