/*
 * Created by yvesb on 23/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CDroitePerpendiculaire = require('../objets/CDroitePerpendiculaire')
const CDroite = require('../objets/CDroite')
const kernel = require('../kernel/kernel')
module.exports = CDroitePerpendiculaire

CDroitePerpendiculaire.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo6') + ' ' + this.d.getNom() + ' ' +
    kernel.getStr('chinfo196') + ' ' + this.a.nom
}

CDroitePerpendiculaire.prototype.contientParDefinition = function (po) {
  return (this.a === po)
}

CDroitePerpendiculaire.prototype.estParalleleParDefinition = function (dte) {
  return this.d.estPerpendiculaireParDefinition(dte) || dte.estPerpendiculaireParDefinition(this.d)
}

CDroitePerpendiculaire.prototype.estPerpendiculaireParDefinition = function (dte) {
  return this.d.estParalleleParDefinition(dte) || dte.estParalleleParDefinition(this.d)
}

CDroitePerpendiculaire.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CDroite.prototype.depDe4Rec.call(this, p) ||
    this.a.depDe4Rec(p) || this.d.depDe4Rec(p))
}

CDroitePerpendiculaire.prototype.estDefiniParObjDs = function (listeOb) {
  return this.a.estDefPar(listeOb) &&
  this.d.estDefPar(listeOb)
}
