/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CLieuDiscretDeBase = require('../objets/CLieuDiscretDeBase')
const kernel = require('../kernel/kernel')
const CElementGraphique = require('../objets/CElementGraphique')
const LieuDlg = require('../dialogs/LieuDlg')
module.exports = CLieuDiscretDeBase

CLieuDiscretDeBase.prototype.depDe4Rec = function (p) {
  return CElementGraphique.prototype.depDe4Rec.call(this, p) || this.pointATracer.depDe4Rec(p)
}

CLieuDiscretDeBase.prototype.distancePoint = function (xp, yp, masquage, distmin) {
  if (!this.existe || (masquage && this.masque)) return -1
  else {
    for (var i = 0; i <= this.indiceDernierPointTrace; i++) {
      var d = kernel.distancePointPoint(xp, yp, this.absPoints[i], this.ordPoints[i])
      if (d < distmin) return d
    }
    return -1
  }
}

CLieuDiscretDeBase.prototype.changeCaracteristiques = function () {
  this.absPoints = new Array(this.nombreDePoints)
  this.ordPoints = new Array(this.nombreDePoints)
}

CLieuDiscretDeBase.prototype.modifiableParMenu = function () {
  return true
}

CLieuDiscretDeBase.prototype.modifDlg = function (app, callBack1, callBack2) {
  new LieuDlg(app, this, true, callBack1, callBack2)
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
// Modifié par rapport à la version Java
CLieuDiscretDeBase.prototype.genereNom = function () {
  CLieuDiscretDeBase.ind++
  return kernel.getStr('rlieud') + CLieuDiscretDeBase.ind
}

CLieuDiscretDeBase.prototype.estDefiniParObjDs = function (listeOb) {
  return this.pointATracer.estDefPar(listeOb)
}
