/*
 * Created by yvesb on 29/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CLieuDiscretParVariable = require('../objets/CLieuDiscretParVariable')
const CLieuDiscretDeBase = require('../objets/CLieuDiscretDeBase')
const kernel = require('../kernel/kernel')
module.exports = CLieuDiscretParVariable

CLieuDiscretParVariable.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('LieuPtDis') + ' ' + kernel.getStr('de') + ' ' + this.pointATracer.nom + ' ' +
    kernel.getStr('chinfo207') + ' ' + this.variableGeneratrice.nomCalcul
}

CLieuDiscretParVariable.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  var ch = ''
  var valeur; var valeurMinimale; var valeurMaximale; var valeurInitiale; var pas; var nb; var i
  var vg = this.variableGeneratrice
  var point1 = this.point1
  var listeElementsAncetres = this.listeElementsAncetres
  point1.donneMotif(this.motif)
  point1.donneCouleur(this.couleur)
  valeurMinimale = vg.valeurMini
  valeurMaximale = vg.valeurMaxi
  valeurInitiale = vg.valeurActuelle
  pas = (valeurMaximale - valeurMinimale) / (this.nombreDePoints - 1)
  valeur = valeurMinimale
  nb = this.nombreDePoints - 1
  for (i = 0; i < this.nombreDePoints; i++) {
    valeur = (i === 0) ? valeurMinimale : ((i === nb) ? valeurMaximale : valeur + pas)
    vg.donneValeur(valeur)
    this.listeElementsAncetres.positionne(false, dimf)
    if (this.pointATracer.existe) {
      if (kernel.testToile(this.pointATracer.x, this.pointATracer.y)) {
        point1.placeEn(this.pointATracer.x, this.pointATracer.y)
        point1.positionne(false, dimf)
        ch += point1.tikz(dimf, false, coefmult, bu)
      }
    }
  }

  // On redonne à la variable génératrice sa valeur initiale
  vg.donneValeur(valeurInitiale)
  listeElementsAncetres.positionne(false, dimf)
  return ch
}

CLieuDiscretParVariable.prototype.estDefiniParObjDs = function (listeOb) {
  return CLieuDiscretDeBase.prototype.estDefiniParObjDs.call(this, listeOb) &&
  this.variableGeneratrice.estDefPar(listeOb)
}
