/*
 * Created by yvesb on 29/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const CLigneBrisee = require('../objets/CLigneBrisee')
module.exports = CLigneBrisee

CLigneBrisee.prototype.infoHist = function () {
  return kernel.getStr('LigneBrisee') + ' ' + this.nomSommets()
}

CLigneBrisee.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  var i, x, y
  var list = this.listeProprietaire
  var ch = '\\draw ' + this.tikzLineStyle(dimf, coefmult) + '('
  var nombrePoints = this.nombrePoints
  for (i = 0; i < nombrePoints - 1; i++) {
    x = list.tikzXcoord(this.absPoints[i], dimf, bu)
    y = list.tikzYcoord(this.ordPoints[i], dimf, bu)
    ch += kernel.chaineNombre(x, 3) + ',' + kernel.chaineNombre(y, 3) + ')--('
  }
  i = nombrePoints - 1
  x = list.tikzXcoord(this.absPoints[i], dimf, bu)
  y = list.tikzYcoord(this.ordPoints[i], dimf, bu)
  ch += kernel.chaineNombre(x, 3) + ',' + kernel.chaineNombre(y, 3) + ');'
  return ch
}
