/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CLongueur = require('../objets/CLongueur')
const kernel = require('../kernel/kernel')
const CValDyn = require('../objets/CValDyn')
module.exports = CLongueur

CLongueur.prototype.utiliseLongueurUnite = function () {
  return true
}

CLongueur.prototype.info = function () {
  return kernel.getStr('chinfo73') + ' ' + this.point1.nom + this.point2.nom
}

CLongueur.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  var resultat = CValDyn.prototype.depDe4Rec.call(this, p) || this.point1.depDe4Rec(p) || this.point2.depDe4Rec(p)
  if ((this.listeProprietaire.pointeurLongueurUnite === this) ||
    this.listeProprietaire.pointeurLongueurUnite === null) { return this.memDep4Rec(resultat) } else return this.memDep4Rec(resultat || (this.listeProprietaire.pointeurLongueurUnite.depDe4Rec(p)))
}

CLongueur.prototype.infoHist = function () {
  var ch = kernel.getStr('chinfo17') + ' ' + this.point1.nom + this.point2.nom
  if (this === this.listeProprietaire.pointeurLongueurUnite) ch = ch + '\n' + kernel.getStr('ch34')
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + ' ' + kernel.chaineNombre(this.longueur, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CLongueur.prototype.estDefiniParObjDs = function (listeOb) {
  return this.point1.estDefPar(listeOb) &&
  this.point2.estDefPar(listeOb)
}
