/*
 * Created by yvesb on 29/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMacro = require('../objets/CMacro')
const kernel = require('../kernel/kernel')
module.exports = CMacro

CMacro.prototype.info = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo224') + ' ' + this.intitule
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
// Modifié par rapport à la version Java
CMacro.prototype.genereNom = function () {
  CMacro.ind++
  return kernel.getStr('rmac') + CMacro.ind
}

CMacro.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CMacro.prototype.peutEtreMacroFinBoucle = function () {
  return false
}

/**
 * Fonction qui renverra true si la macro est une macro avec liste à laquelle on peut ajouter ou retirer des objets
 * @returns {boolean}
 */
CMacro.prototype.ajoutOuRetraitObjetsPossible = function () {
  return false
}

/**
 * Fonctin qui renerra true si la macro peut être une macro lancée quand on ouvre la figure c'est à dire
 * une macro d'implémentation récursive ou itérative ou une macro d'exécution d'une suite de telles macros
 * @returns {boolean}
 */
CMacro.prototype.utilisablePourDemarrage = function () {
  return false
}

/**
 * Fonction renvoyant une chaîne de acractères à rajoutet à this.infoHist()
 * Utilisé dans l'historique
 * @returns {string}
 */
CMacro.prototype.infoHist = function () {
  var ch = this.info()
  if (this.pointLie !== null) ch += '\n' + kernel.getStr('liea') + ' ' + this.pointLie.nom
  return ch
}
