/*
 * Created by yvesb on 30/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CAffLiePt = require('../objets/CAffLiePt')
const CMacroAnimationPointLie = require('../objets/CMacroAnimationPointLie')
module.exports = CMacroAnimationFigure

/**
 * Macro servant à exécuter l'outil d'animation d'un point lié de la figure
 * @param app L'application MtgApp propriétaire
 * @constructor
 */
function CMacroAnimationFigure (app) {
  CMacroAnimationPointLie.call(this, app.listePr, null, false, null,
    0, 0, 0, 0, true, null, 0, false, null,
    CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, '', '', true, 20, 100,
    0, null, false, true, false)
  this.app = app
  this.timer = null
}

CMacroAnimationFigure.prototype = new CMacroAnimationPointLie()

/**
 * Fonction terminant l'action d'animation d'un point lié de la figure
 * @param svg
 * @param dimf
 * @param couleurFond
 * @param transparence
 * @param bReselect Si true on resélectionne l'otuil d'animation
 */
CMacroAnimationFigure.prototype.termineAction = function (svg, dimf, couleurFond, transparence, bReselect = true) {
  clearInterval(this.timer)
  this.timer = null
  this.executionEnCours = false
  if (this.retourDepart && (this.pointLieAssocie !== null)) this.pointLieAssocie.donneAbscisse(this.abscisseInitiale)
  this.listeDep.positionne(false, dimf)
  this.listeDep.update(svg, couleurFond, transparence, true)
  this.passageMacroSuiv(svg, dimf, couleurFond, transparence)
  // this.app.activeOutilCapt();
  if (bReselect) this.app.outilAnimation.reselect()
}

CMacroAnimationFigure.prototype.resetTimer = function () {
  if (this.timer !== null) clearInterval(this.timer)
}
