/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMacroAnimationPointLie = require('../objets/CMacroAnimationPointLie')
const CMacro = require('../objets/CMacro')
const kernel = require('../kernel/kernel')
const MacroAnimDlg = require('../dialogs/MacAnimDlg')
module.exports = CMacroAnimationPointLie

CMacroAnimationPointLie.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo124') + ' ' + this.pointLieAssocie.nom
}

CMacroAnimationPointLie.prototype.estGenereParPointLie = function (pointlie) {
  return this.pointLieAssocie === pointlie
}

CMacroAnimationPointLie.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CMacro.prototype.depDe4Rec.call(this, p) ||
    this.pointLieAssocie.depDe4Rec(p))
}

CMacroAnimationPointLie.prototype.modifDlg = function (app, callBack1, callBack2) {
  new MacroAnimDlg(app, false, this, true, callBack1, callBack2)
}

CMacroAnimationPointLie.prototype.estDefiniParObjDs = function (listeOb) {
  return CMacro.prototype.estDefiniParObjDs.call(this, listeOb) &&
    this.pointLieAssocie.estDefPar(listeOb)
}
