/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMacroBoucleAvecAnimation = require('../objets/CMacroBoucleAvecAnimation')
const CMacro = require('../objets/CMacro')
const kernel = require('../kernel/kernel')
const MacBoucDlg = require('../dialogs/MacBoucDlg')
module.exports = CMacroBoucleAvecAnimation

CMacroBoucleAvecAnimation.prototype.infoHist = function () {
  return this.intitule + ' : ' + kernel.getStr('chinfo130') + '\n' + kernel.getStr('chinfo133') +
    ' ' + this.variableAssociee.nomCalcul
}

CMacroBoucleAvecAnimation.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  var resultat = false
  if (this.macroAvantBoucles !== null) { resultat |= this.macroAvantBoucles.depDe4Rec(p) }
  if (this.macroFinBoucle !== null) { resultat |= this.macroFinBoucle.depDe4Rec(p) }
  return this.memDep4Rec(resultat || CMacro.prototype.depDe4Rec.call(this, p))
}

CMacroBoucleAvecAnimation.prototype.modifDlg = function (app, callBack1, callBack2) {
  new MacBoucDlg(app, this, true, callBack1, callBack2)
}

CMacroBoucleAvecAnimation.prototype.estDefiniParObjDs = function (listeOb) {
  return CMacro.prototype.estDefiniParObjDs.call(this, listeOb) &&
    this.variableAssociee.estDefPar(listeOb) &&
    this.macroAvantBoucles.estDefPar(listeOb) &&
    this.macroFinBoucle.estDefPar(listeOb)
}
