/*
 * Created by yvesb on 21/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMacroBoucleAvecTrace = require('../objets/CMacroBoucleAvecTrace')
const CMacroAvecListe = require('../objets/CMacroAvecListe')
const kernel = require('../kernel/kernel')
const MacBoucDlg = require('../dialogs/MacBoucDlg')

module.exports = CMacroBoucleAvecTrace

CMacroBoucleAvecTrace.prototype.infoHist = function () {
  return this.intitule + ' : ' + kernel.getStr('chinfo130') + '\n' + kernel.getStr('chinfo133') +
    ' ' + this.variableAssociee.nomCalcul
}

CMacroBoucleAvecTrace.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  var res = false
  if (this.macroAvantBoucles !== null) { res |= this.macroAvantBoucles.depDe4Rec(p) }
  if (this.macroFinBoucle !== null) { res |= this.macroFinBoucle.depDe4Rec(p) }
  return this.memDep4Rec(res || CMacroAvecListe.prototype.depDe4Rec.call(this, p))
}

CMacroBoucleAvecTrace.prototype.modifDlg = function (app, callBack1, callBack2) {
  new MacBoucDlg(app, this, true, callBack1, callBack2)
}
