/*
 * Created by yvesb on 23/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMediatrice = require('../objets/CMediatrice')
const CDroite = require('../objets/CDroite')
const kernel = require('../kernel/kernel')
module.exports = CMediatrice

CMediatrice.prototype.info = function () {
  return this.getNom() + ' : ' + kernel.getStr('DtMed') + ' ' + kernel.getStr('de') + ' [' +
    this.point1.nom + this.point2.nom + ']'
}

CMediatrice.prototype.estPerpendiculaireParDefinition = function (dte) {
  return this.listeProprietaire.sontParDefinitionSurParallele(this.point1, this.point2, dte)
}

CMediatrice.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CDroite.prototype.depDe4Rec.call(this, p) ||
    this.point1.depDe4Rec(p) || this.point2.depDe4Rec(p))
}

CMediatrice.prototype.estDefiniParObjDs = function (listeOb) {
  return this.point1.estDefPar(listeOb) &&
  this.point2.estDefPar(listeOb)
}
