/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CPointBase = require('../objets/CPointBase')
const CPointAncetrePointsMobiles = require('../objets/CPointAncetrePointsMobiles')
const kernel = require('../kernel/kernel')
module.exports = CPointBase

CPointBase.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('PointLibre')
}

/**
 * Fonction translatant le point de (decalagex, decalagey)
 * @param {Number} decalagex
 * @param {Number} decalagey
 * @returns {undefined}
 */
CPointBase.prototype.translateDe = function (decalagex, decalagey) {
  this.x += decalagex
  this.y += decalagey
}

CPointBase.prototype.adaptRes = function (coef) {
  CPointAncetrePointsMobiles.prototype.adaptRes.call(this, coef)
  this.x *= coef
  this.y *= coef
}

CPointBase.prototype.estDefiniParObjDs = function (listeOb) {
  return listeOb.contains(this)
}
