/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CPointLieDroite = require('../objets/CPointLieDroite')
const CPointLie = require('../objets/CPointLie')
const kernel = require('../kernel/kernel')
module.exports = CPointLieDroite

CPointLieDroite.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo2') + ' ' + this.droiteLiee.getNom()
}

CPointLieDroite.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPointLie.prototype.depDe4Rec.call(this, p) ||
    this.droiteLiee.depDe4Rec(p))
}

/**
 * Renvoie l'objet auquel le point est lié
 * @returns {CDroiteAncetre}
 */
CPointLieDroite.prototype.lieA = function () {
  return this.droiteLiee
}

CPointLieDroite.prototype.appartientDroiteParDefinition = function (droite) {
  return CPointLie.prototype.appartientDroiteParDefinition.call(this, droite) || (droite === this.droiteLiee)
}

CPointLieDroite.prototype.estDefiniParObjDs = function (listeOb) {
  return this.droiteLiee.estDefPar(listeOb)
}
