/*
 * Created by yvesb on 16/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CPointParMultVect = require('../objets/CPointParMultVect')
const CPt = require('../objets/CPt')
const PtParMultVecDlg = require('../dialogs/PtParMultVecDlg')
const kernel = require('../kernel/kernel')
module.exports = CPointParMultVect

CPointParMultVect.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo217') + ' ' + kernel.getStr('chinfo218') + '(' +
    this.antecedent.nom + this.nom + ') = ' + this.coef.chaineInfo() + '.' + kernel.getStr('chinfo218') + '(' +
    this.vect.point1.nom + this.vect.point2.nom + ')'
}

CPointParMultVect.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPt.prototype.depDe4Rec.call(this, p) ||
    this.antecedent.depDe4Rec(p) || this.vect.depDe4Rec(p) || this.coef.depDe4Rec(p))
}

CPointParMultVect.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CPointParMultVect.prototype.modifDlg = function (app, callBack1, callBack2) {
  new PtParMultVecDlg(app, this, true, callBack1, callBack2)
}

CPointParMultVect.prototype.estDefiniParObjDs = function (listeOb) {
  return this.antecedent.estDefPar(listeOb) &&
  this.vect.estDefPar(listeOb) &&
  this.coef.estDefiniParObjDs(listeOb)
}
