/*
 * Created by yvesb on 23/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CPointProjete = require('../objets/CPointProjete')
const CPt = require('../objets/CPt')
const kernel = require('../kernel/kernel')
module.exports = CPointProjete

CPointProjete.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('proj') + ' ' + kernel.getStr('de') + ' ' + this.a.nom +
    ' ' + kernel.getStr('sur') + ' ' + this.d.getNom()
}

CPointProjete.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPt.prototype.depDe4Rec.call(this, p) ||
    this.a.depDe4Rec(p) || this.d.depDe4Rec(p))
}

CPointProjete.prototype.appartientDroiteParDefinition = function (droite) {
  return CPt.prototype.appartientDroiteParDefinition.call(this, droite) || (droite === this.d)
}

CPointProjete.prototype.estDefiniParObjDs = function (listeOb) {
  return this.a.estDefPar(listeOb) &&
  this.d.estDefPar(listeOb)
}
