/*
 * Created by yvesb on 21/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CSurface = require('../objets/CSurface')
const CSurfaceAncetre = require('../objets/CSurfaceAncetre')
const kernel = require('../kernel/kernel')
module.exports = CSurface

CSurface.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo60') + ' ' + this.bord.nom
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CSurface.prototype.genereNom = function () {
  CSurface.ind++
  return kernel.getStr('Surf') + CSurface.ind
}

CSurface.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CSurfaceAncetre.prototype.depDe4Rec.call(this, p) ||
    this.bord.depDe4Rec(p))
}

CSurface.prototype.estDefiniParObjDs = function (listeOb) {
  return this.bord.estDefPar(listeOb)
}
