/*
 * Created by yvesb on 21/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CSymetrieCentrale = require('../objets/CSymetrieCentrale')
const CTransformation = require('../objets/CTransformation')
const kernel = require('../kernel/kernel')
module.exports = CSymetrieCentrale

CSymetrieCentrale.prototype.complementInfo = function () {
  return kernel.getStr('SymCentrale') + ' ' + kernel.getStr('chinfo202') + ' ' + this.centre.nom
}

CSymetrieCentrale.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CTransformation.prototype.depDe4Rec.call(this, p) ||
    this.centre.depDe4Rec(p))
}

CSymetrieCentrale.prototype.ajouteAntecedents = function (list) {
  list.add(this.centre)
}

CSymetrieCentrale.prototype.estDefiniParObjDs = function (listeOb) {
  return this.centre.estDefPar(listeOb)
}
