/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CTestEquivalence = require('../objets/CTestEquivalence')
const kernel = require('../kernel/kernel')
const CCalculAncetre = require('../objets/CCalculAncetre')
const TestFactDlg = require('../dialogs/TestEqFactDlg')

module.exports = CTestEquivalence

CTestEquivalence.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CCalculAncetre.prototype.depDe4Rec.call(this, p) ||
    this.calcul1.depDe4Rec(p) || this.calcul2.depDe4Rec(p) || this.test.depDe4Rec(p))
}

CTestEquivalence.prototype.infoHist = function () {
  var ch = this.getNom() + ' : ' + kernel.getStr('ch186') + '\n' + this.calcul1.getNom() + ' ' +
    kernel.getStr('et') + ' ' + this.calcul2.getNom() + '\n'
  ch = ch + this.calcul1.getNom() + ' : ' + (this.remplacementValeurs1 ? kernel.getStr('ch187') : kernel.getStr('ch188'))
  ch = ch + kernel.getStr('ch189') + '\n'
  ch = ch + this.calcul2.getNom() + ' : ' + (this.remplacementValeurs2 ? kernel.getStr('ch187') : kernel.getStr('ch188'))
  ch = ch + kernel.getStr('ch189') + '\n'
  ch = ch + kernel.getStr('testEquivalenceDlg4') + ' ' + this.test.chaineInfo() + '\n'
  ch = ch + kernel.getStr('chinfo97') + ' ' + kernel.chaineNombre(this.resultat, 12)
  return ch
}

CTestEquivalence.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CTestEquivalence.prototype.modifDlg = function (app, callBack1, callBack2) {
  new TestFactDlg(app, this, true, true, callBack1, callBack2)
}

CTestEquivalence.prototype.estDefiniParObjDs = function (listeOb) {
  return this.calcul1.estDefPar(listeOb) &&
  this.calcul2.estDefPar(listeOb)
}
