/*
 * Created by yvesb on 21/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CTranslation = require('../objets/CTranslation')
const CTransformation = require('../objets/CTransformation')
const CVecteur = require('../objets/CVecteur')
const StyleTrait = require('../types/StyleTrait')
const StyleFleche = require('../types/StyleFleche')
const Color = require('../types/Color')
const kernel = require('../kernel/kernel')
module.exports = CTranslation

CTranslation.prototype.complementInfo = function () {
  return kernel.getStr('Trans') + ' ' + 'T(' + this.or.nom + this.ex.nom + ')'
}

CTranslation.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CTransformation.prototype.depDe4Rec.call(this, p) ||
    this.or.depDe4Rec(p) || this.ex.depDe4Rec(p))
}

CTranslation.prototype.ajouteAntecedents = function (list, app) {
  list.add(this.or)
  list.add(this.ex)
  // On crée en plus un vecteur clignotant pour visualiser la translation
  // Important : Le premier paramètre correspondant à la liste propriétaire est null
  // de façon à ce que OutilProtocole.annuleClignotement retire l'implémentation graphique
  // du vecteur rajouté
  var vecteurClignotant = new CVecteur(list, null, false, Color.blue, false,
    new StyleTrait(list, StyleTrait.styleTraitContinu, 2),
    this.or, this.ex, StyleFleche.FlecheLonguePleine)
  // On donne à ce vecteur un membre isTransit qui sera utilisé dans l'outil OutilProtocole dans la fonction
  // annuleclignotement
  vecteurClignotant.isTransit = true
  vecteurClignotant.positionne()
  vecteurClignotant.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
  list.add(vecteurClignotant)
}

CTranslation.prototype.estDefiniParObjDs = function (listeOb) {
  return this.or.estDefPar(listeOb) &&
  this.ex.estDefPar(listeOb)
}
