/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CUnitexRep = require('../objets/CUnitexRep')
const kernel = require('../kernel/kernel')
const InfoRepDlg = require('../dialogs/InfoRepDlg')

module.exports = CUnitexRep

CUnitexRep.prototype.infoHist = function () {
  var ch = this.getNom() + ' : ' + kernel.getStr('chinfo180') + '\n' + kernel.getStr('chinfo32') + ' ' + this.rep.getNom()
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + ' ' + kernel.chaineNombre(this.abscisseOrigine, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CUnitexRep.prototype.modifDlg = function (app, callBack1, callBack2) {
  new InfoRepDlg(app, this, 2, true, callBack1, callBack2)
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CUnitexRep.prototype.genereNom = function () {
  CUnitexRep.ind++
  return kernel.getStr('ruxrep') + CUnitexRep.ind
}
