/*
 * Created by yvesb on 13/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const CValeurAffichee = require('../objets/CValeurAffichee')
const OutilObjetPar1Objet = require('./OutilObjetPar1Objet')
const AffichageValeurDlg = require('../dialogs/AffichageValeurDlg')
const CAffLiePt = require('../objets/CAffLiePt')
const StyleEncadrement = require('../types/StyleEncadrement')
const AvertDlg = require('../dialogs/AvertDlg')
module.exports = OutilAffichageValeurLiePt
/**
 * Outil servant à créer une droite horizontale
 * @param app L'application propriétaire
 * @constructor
 */
function OutilAffichageValeurLiePt (app) {
  OutilObjetPar1Objet.call(this, app, 'AffichageValeurLiePt', 32821, true, NatObj.NTtPoint)
}

OutilAffichageValeurLiePt.prototype = new OutilObjetPar1Objet()

OutilAffichageValeurLiePt.prototype.indication = function () {
  return 'indAffLie'
}

OutilAffichageValeurLiePt.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  var list = app.listePr
  this.valaff = new CValeurAffichee(list, null, false, app.getCouleur(), 0, 0, 0, 0, false, elg, 16, StyleEncadrement.Sans,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, null, '', '', 2)
  var self = this
  new AffichageValeurDlg(app, this.valaff, false, function () { self.callBackOK() }, function () { self.callBackCancel() })
}

// Pas d'objets visuels pour cet outil
OutilAffichageValeurLiePt.prototype.ajouteObjetsVisuels = function () {}

/**
 * Fonction de callback créant l'objet si la boîte de dialoge a été validée
 */
OutilAffichageValeurLiePt.prototype.callBackOK = function () {
  const app = this.app
  app.ajouteElement(this.valaff)
  if (app.verifieDernierElement(1)) {
    // L'élément créé existe bien et a été ajouté à la liste
    this.valaff.setReady4MathJax() // Ajouté version 6.4.1
    const self = this
    MathJax.Hub.Queue(function () { // Ajouté version 6.4.1
      self.valaff.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    })
    this.annuleClignotement()
    this.saveFig()
    app.activeOutilCapt()
  } else new AvertDlg(app, 'DejaCree')
}

OutilAffichageValeurLiePt.prototype.callBackCancel = function () {
  this.app.activeOutilCapt()
}
