/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
module.exports = OutilAnnuler
/**
 * Outil annulant la dernière action sur la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilAnnuler (app) {
  Outil.call(this, app, 'Cancel', -1)
}
OutilAnnuler.prototype = new Outil()

OutilAnnuler.prototype.select = function () {
  Outil.prototype.select.call(this)
  this.app.gestionnaire.annuleAction()
  this.app.activeOutilCapt()
}

OutilAnnuler.prototype.activationValide = function () {
  return this.app.gestionnaire.annulationPossible()
}
