/*
 * Created by yvesb on 10/01/2017.
 */
/**
 * Outil servant à créer un petie arc de cercle en cliquant sur deux points
 * @param app L'application propriétaire
 * @constructor
 */
const OutilPar2Pts = require('../outils/OutilPar2Pts')
const CValeurAngle = require('../objets/CValeurAngle')
const CArcDeCercle = require('../objets/CArcDeCercle')
const AngleArcDlg = require('../dialogs/AngleArcDlg')
const CConstante = require('../objets/CConstante')
const AvertDlg = require('../dialogs/AvertDlg')
module.exports = OutilArcPetitParAng

function OutilArcPetitParAng (app, toolName, toolIndex, avecClig) {
  if (arguments.length === 1) OutilPar2Pts.call(this, app, 'ArcPetitParAng', 32798, true, false)
  else OutilPar2Pts.call(this, app, toolName, toolIndex, avecClig, false)
}

OutilArcPetitParAng.prototype = new OutilPar2Pts()
OutilArcPetitParAng.prototype.constructor = OutilArcPetitParAng

OutilArcPetitParAng.prototype.select = function () {
  this.app.outilPointageActif = this.app.outilPointageCre
  OutilPar2Pts.prototype.select.call(this) // A appeler à la fin
}

OutilArcPetitParAng.prototype.creeObjet = function () {
  var app = this.app
  var self = this
  // if (app.lastDlgId() === "angleArcDlg") return;
  var li = app.listePr
  var ang = new CValeurAngle(li, new CConstante(li, 1))
  this.arc = new CArcDeCercle(li, null, false, app.getCouleur(), false, app.getStyleTrait(), this.point1, this.point2, null, ang)
  new AngleArcDlg(this.app, this.arc, false, function () { self.actionApresDlgOK() }, function () { self.reselect() })
}

OutilArcPetitParAng.prototype.indication = function (ind) {
  switch (ind) {
    case 1 : return 'indCentre'
    case 2 : return 'debArc'
  }
}

OutilArcPetitParAng.prototype.actionApresDlgOK = function () {
  var app = this.app
  app.ajouteElement(this.arc)
  if (app.verifieDernierElement(1)) {
    this.nbPtsCrees = 0
    // Le cercle créé existe bien et n'a pas été déjà créé
    this.arc.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    this.annuleClignotement() // Pour que le centre clignotant ne soit pas enregistré comme caché
    this.saveFig()
    this.reselect()
  } else {
    new AvertDlg(app, 'DejaCree')
    this.reselect()
  }
}

/**
 * Fonction renvoyant true si l'outil accepte qu'on crée un point par défaut lors d'un clic sur un endroit vide
 */
OutilArcPetitParAng.prototype.creationPointPossible = function () {
  return true
}
