/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const ChoixSrcNumDlg = require('../dialogs/ChoixSrcNumDlg')
const NatCal = require('../types/NatCal')

module.exports = OutilChoixSrcNumConst

function OutilChoixSrcNumConst (app) {
  // Attention : Pour cet outil le troisième pramètre est "CreationConst" pour que l'icône de app.outilGestionConst soit
  // désactivée quand on désactive l'outil (cet outil n'a pas d'icône)
  Outil.call(this, app, 'CreationConst', -1, false, true)
}

OutilChoixSrcNumConst.prototype = new Outil()

OutilChoixSrcNumConst.prototype.select = function () {
  var app = this.app
  new ChoixSrcNumDlg(app)
}

OutilChoixSrcNumConst.prototype.activationValide = function () {
  return this.app.listePr.nombreObjetsCalcul(NatCal.NTtObjNumSaufConst) > 0
}
