/*
 * Created by yvesb on 18/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const kernel = require('../kernel/kernel')
const CCommentaire = require('../objets/CCommentaire')
const CommentaireDlg = require('../dialogs/CommentaireDlg')
const AvertDlg = require('../dialogs/AvertDlg')
const CAffLiePt = require('../objets/CAffLiePt')
const Color = require('../types/Color')
const StyleEncadrement = require('../types/StyleEncadrement')
module.exports = OutilCommentaire
/**
 * Outil servant à créer un affichage de valeur libre sur la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilCommentaire (app) {
  Outil.call(this, app, 'Commentaire', 32857, true)
}
OutilCommentaire.prototype = new Outil()

OutilCommentaire.prototype.select = function () {
  var app = this.app
  Outil.prototype.select.call(this)
  app.outilPointageActif = this.app.outilPointageClic
  app.outilPointageActif.reset()
  app.indication('indEndroitAff')
}

OutilCommentaire.prototype.traiteObjetDesigne = function (elg, point) {
  var app = this.app
  var list = app.listePr
  this.comClig = new CCommentaire(list, null, false, Color.black, point.x, point.y, 0, 0, false, null, 16, StyleEncadrement.Sans,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop,
    kernel.getStr('AffIci'))
  this.comClig.positionne(false, app.dimf)
  this.comClig.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
  this.ajouteClignotementDe(this.comClig)
  this.resetClignotement()
  var self = this
  this.comm = new CCommentaire(list, null, false, app.getCouleur(), point.x, point.y, 0, 0, false, null, 16, StyleEncadrement.Sans,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, '')
  new CommentaireDlg(app, this.comm, false, function () { self.callBackOK() }, function () { self.app.activeOutilCapt() })
}

OutilCommentaire.prototype.callBackOK = function () {
  var app = this.app
  var self = this
  app.ajouteElement(this.comm)
  var verif = app.verifieDernierElement(1)
  if (verif) {
    // L'élément créé existe bien et a été ajouté à la liste
    this.comm.setReady4MathJax() // Pour le cas où le commentaire commence et finit par un $
    MathJax.Hub.Queue(function () {
      self.comm.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    })
    this.annuleClignotement()
    this.saveFig()
  } else new AvertDlg(app, 'DejaCree')
  app.activeOutilCapt()
}
