/*
 * Created by yvesb on 18/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const CCommentaire = require('../objets/CCommentaire')
const OutilObjetPar1Objet = require('./OutilObjetPar1Objet')
const CAffLiePt = require('../objets/CAffLiePt')
const StyleEncadrement = require('../types/StyleEncadrement')
const CommentaireDlg = require('../dialogs/CommentaireDlg')
const AvertDlg = require('../dialogs/AvertDlg')

module.exports = OutilCommentaireLiePt

/**
 * Outil servant à créer une droite horizontale
 * @param app L'application propriétaire
 * @constructor
 */
function OutilCommentaireLiePt (app) {
  OutilObjetPar1Objet.call(this, app, 'CommentaireLiePt', 32860, true, NatObj.NTtPoint)
}

OutilCommentaireLiePt.prototype = new OutilObjetPar1Objet()

OutilCommentaireLiePt.prototype.indication = function () {
  return 'indAffLie'
}

OutilCommentaireLiePt.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  var list = app.listePr
  this.comm = new CCommentaire(list, null, false, app.getCouleur(), 0, 0, 0, 0, false, elg, 16, StyleEncadrement.Sans,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, '')
  var self = this
  new CommentaireDlg(app, this.comm, false, function () { self.callBackOK() }, function () { self.app.activeOutilCapt() })
}

OutilCommentaireLiePt.prototype.ajouteObjetsVisuels = function () {}

/**
 * Fonction de callback créant l'objet si la boîte de dialoge a été validée
 */
OutilCommentaireLiePt.prototype.callBackOK = function () {
  var app = this.app
  app.ajouteElement(this.comm)
  var self = this
  if (app.verifieDernierElement(1)) {
    // L'élément créé existe bien et a été ajouté à la liste
    // Modification version 6.4 : Il faut passer par la pile d'appels au cas où le texte à afficher commmence et finit par un $
    MathJax.Hub.Queue(function () {
      self.comm.creeAffichage(self.app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    })
    // this.comm.creeAffichage(this.app.svgFigure, false, app.doc.couleurFond, app.doc.opacity);
    this.annuleClignotement()
    this.saveFig()
    app.activeOutilCapt()
  } else new AvertDlg(app, 'DejaCree')
}
