/*
 * Created by yvesb on 22/09/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const NatObj = require('../types/NatObjAdd')
module.exports = OutilCopierStyle
/**
 * Outil servant à créer un cercle défini apr centre et point
 * @param app L'application mtgApp propriétaire
 * @constructor
 */
function OutilCopierStyle (app) {
  Outil.call(this, app, 'CopierStyle', 32820, true)
}

OutilCopierStyle.prototype = new Outil()

OutilCopierStyle.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  app.outilPointageActif = app.outilPointageCre
  app.outilPointageActif.aDesigner = NatObj.NTtObj
  app.outilPointageActif.reset()
  app.indication('CopSty1')
}

OutilCopierStyle.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  app.selectColor(elg.couleur)
  if (elg.estDeNature(NatObj.NObjLigne)) {
    app.selectLineStyle(elg.style)
    app.selectThickness(elg.style.strokeWidth)
  }
  if (elg.estDeNature(NatObj.NSurface)) {
    app.selectFillStyle(elg.styleRemplissage)
  }
  this.deselect()
  app.outilActif = app.outilPalette
  app.outilPalette.select()
}
