/*
 * Created by yvesb on 27/09/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const CDroiteDirectionFixe = require('../objets/CDroiteDirectionFixe')
const OutilObjetPar1Objet = require('./OutilObjetPar1Objet')
module.exports = OutilDtHor
/**
 * Outil servant à créer une droite horizontale
 * @param app L'application propriétaire
 * @constructor
 */
function OutilDtHor (app) {
  OutilObjetPar1Objet.call(this, app, 'DtHor', 32862, true, NatObj.NTtPoint)
}

OutilDtHor.prototype = new OutilObjetPar1Objet()

OutilDtHor.prototype.indication = function () {
  return 'indPt'
}

OutilDtHor.prototype.objet = function (pt) {
  var app = this.app
  return new CDroiteDirectionFixe(app.listePr, null, false, app.getCouleur(), true, 0, 0, false, '', app.getTaillePoliceNom(),
    app.getStyleTrait(), 0.9, pt, true, 1)
}

/**
 * Fonction renvoyant true si l'outil accepte qu'on crée un point par défaut lors d'un clic sur un endroit vide
 */
OutilDtHor.prototype.creationPointPossible = function () {
  return true
}
