/*
 * Created by yvesb on 25/09/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Color = require('../types/Color')
const StyleTrait = require('../types/StyleTrait')
const CDroitePerpendiculaire = require('../objets/CDroitePerpendiculaire')
const CMarqueAngleDroit = require('../objets/CMarqueAngleDroit')
const OutilParDtPt = require('./OutilParDtPt')
const StyleMarqueAngle = require('../types/StyleMarqueAngle')
module.exports = OutilDtPer
/**
 * Outil servant à créer 'une droite perpendiculaire
 * @param app L'application propriétaire
 * @constructor
 */
function OutilDtPer (app) {
  OutilParDtPt.call(this, app, 'DtPer', 32786, true)
}

OutilDtPer.prototype = new OutilParDtPt()

OutilDtPer.prototype.objet = function (pt, dt) {
  var app = this.app
  return new CDroitePerpendiculaire(app.listePr, null, false, app.getCouleur(), false, 0, 0, false, '', app.getTaillePoliceNom(),
    app.getStyleTrait(), 0.9, pt, dt)
}

OutilDtPer.prototype.ajouteObjetsVisuels = function () {
  var app = this.app
  var list = app.listeObjetsVisuels
  var dp = this.objet(this.app.mousePoint, this.droite1)
  app.ajouteObjetVisuel(dp)
  var mad = new CMarqueAngleDroit(list, null, false, Color.black, false,
    new StyleTrait(list, StyleTrait.styleTraitContinu, 2), StyleMarqueAngle.marqueSimple, 13, dp)
  app.ajouteObjetVisuel(mad)
  app.afficheObjetVisuels(0) // Ajout version 6.4.4
}

/**
 * Fonction renvoyant true si l'outil accepte qu'on crée un point par défaut lors d'un clic sur un endroit vide
 */
OutilDtPer.prototype.creationPointPossible = function () {
  return true
}
