/*
 * Created by yvesb on 14/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const kernel = require('../kernel/kernel')
const CCommentaire = require('../objets/CCommentaire')
const CEditeurFormule = require('../objets/CEditeurFormule')
const EditeurFormuleDlg = require('../dialogs/EditeurFormuleDlg')
const CAffLiePt = require('../objets/CAffLiePt')
const Color = require('../types/Color')
const StyleEncadrement = require('../types/StyleEncadrement')
const NatCal = require('../types/NatCal')
module.exports = OutilEditeurFormule

function OutilEditeurFormule (app) {
  Outil.call(this, app, 'EditeurFormule', 32036, true)
}
OutilEditeurFormule.prototype = new Outil()

OutilEditeurFormule.prototype.select = function () {
  var app = this.app
  Outil.prototype.select.call(this)
  app.outilPointageActif = this.app.outilPointageClic
  app.outilPointageActif.reset()
  app.indication('indEndroitAff')
}

OutilEditeurFormule.prototype.traiteObjetDesigne = function (elg, point) {
  var app = this.app
  var list = app.listePr
  var com = new CCommentaire(list, null, false, Color.black, point.x, point.y, 0, 0, false, null, 13, StyleEncadrement.Sans, false,
    app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, kernel.getStr('AffIci'))
  this.ajouteClignotementDe(com)
  this.resetClignotement()
  var self = this
  this.editeur = new CEditeurFormule(list, null, false, app.getCouleur(), point.x, point.y, 0, 0, false, null, 14,
    StyleEncadrement.Sans, false, app.doc.couleurFond, null, '', 12, false, '=', false, true, true)
  /*
  this.comm = new CCommentaire(list, null, false, app.getCouleur(), point.x, point.y, 0, 0, false, null, 16, StyleEncadrement.Sans,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, "")
  new CommentaireDlg(app, this.comm, false, function() {self.callBackOK()}, function() {self.app.activeOutilCapt()});
  */
  new EditeurFormuleDlg(app, this.editeur, false, function () { self.callBackOK() }, function () { self.app.activeOutilCapt() })
}

OutilEditeurFormule.prototype.callBackOK = function () {
  var app = this.app
  app.ajouteElement(this.editeur)
  this.annuleClignotement()
  this.saveFig()
  app.activeOutilCapt()
}

OutilEditeurFormule.prototype.activationValide = function () {
  return this.app.listePr.nombreObjetsCalcul(NatCal.NCalculOuFonctionParFormule) > 0
}
