/*
 * Created by yvesb on 11/02/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const NatObj = require('../types/NatObj')

module.exports = OutilExecutionMacro

/**
 * Outil servant à modifier le style de tracé ou la couleur d'un objet
 * @param app L'application propriétaire
 * @constructor
 */
function OutilExecutionMacro (app) {
  Outil.call(this, app, 'ExecutionMacro', 32942, false)
}

OutilExecutionMacro.prototype = new Outil()

OutilExecutionMacro.prototype.select = function () {
  var app = this.app
  Outil.prototype.select.call(this)
  app.listePr.terminerMacros = false // Ajout version 6.4. Utilisé dans CMacro.passageMacroSuivante
  app.outilPointageActif = app.outilPointageExecMac
  app.outilPointageActif.aDesigner = NatObj.NMacro
  app.outilPointageActif.reset()
  this.cursor = 'crosshair'
  // alert(app.reponseValide());
}

OutilExecutionMacro.prototype.deselect = function () {
  var app = this.app
  var list = app.listePr
  var doc = app.doc
  if (list.macroEnCours !== null) list.macroEnCours.macroEnCours().termineAction(app.svgFigure, app.dimf, doc.couleurFond, doc.opacity)
  Outil.prototype.deselect.call(this)
}
