/*
 * Created by yvesb on 15/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CGrapheSuiteRecComp = require('../objets/CGrapheSuiteRecComplexe')
const GrapheSuiteRecDlg = require('../dialogs/GrapheSuiteRecDlg')
const NatCal = require('../types/NatCal')
const AvertDlg = require('../dialogs/AvertDlg')

module.exports = OutilGrapheSuiteRecComp

function OutilGrapheSuiteRecComp (app) {
  Outil.call(this, app, 'GrapheSuiteRecComp', 33145)
}
OutilGrapheSuiteRecComp.prototype = new Outil()

OutilGrapheSuiteRecComp.prototype.select = function () {
  Outil.prototype.select.call(this)
  var self = this
  var app = this.app
  var list = app.listePr
  // this.graphe = new CGrapheSuiteRecComp(list, null, false, app.getCouleur(), false, app.getStyleTrait(), null, null, true);
  this.graphe = new CGrapheSuiteRecComp(list, null, false, app.getCouleur(), false, app.getStyleTrait(), null, null, app.getStylePoint(), true)
  new GrapheSuiteRecDlg(app, this.graphe, false, false, function () { self.callBackOK() }, function () { self.app.activeOutilCapt() })
  this.app.activeOutilCapt()
}

OutilGrapheSuiteRecComp.prototype.activationValide = function () {
  var list = this.app.listePr
  return (list.nombreObjetsCalcul(NatCal.NRepere) > 0) && (list.nombreObjetsCalcul(NatCal.NSuiteRecurrenteComplexe) > 0)
}

/**
 * Fonction de callback créant l'objet si la boîte de dialoge a été validée
 */
OutilGrapheSuiteRecComp.prototype.callBackOK = function () {
  var app = this.app
  app.ajouteElement(this.graphe)
  if (app.verifieDernierElement(1)) {
    // L'élément créé existe bien et a été ajouté à la liste
    this.graphe.creeAffichage(this.app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    this.saveFig()
    app.activeOutilCapt()
  } else new AvertDlg(app, 'DejaCree')
}
