/*
 * Created by yvesb on 10/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const kernel = require('../kernel/kernel')
const CImage = require('../objets/CImage')
const ImageDlg = require('../dialogs/ImageDlg')
const StyleEncadrement = require('../types/StyleEncadrement')
const CAffLiePt = require('../objets/CAffLiePt')
module.exports = OutilImageLibre
/**
 * Outil servant à créer une image libre sur la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilImageLibre (app) {
  Outil.call(this, app, 'ImageLibre', 33097, false)
}
OutilImageLibre.prototype = new Outil()

OutilImageLibre.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  app.outilPointageActif = this.app.outilPointageClic
  app.outilPointageActif.reset()
  app.indication('indImage')
}

OutilImageLibre.prototype.traiteObjetDesigne = function (elg, point) {
  var app = this.app
  var self = this
  this.image = new CImage(app.listePr, null, false, app.getCouleur(), point.x, point.y, 0, 0, false, null, 13,
    StyleEncadrement.Sans, false, app.doc.couleurFond, CAffLiePt.alignHorCent,
    CAffLiePt.alignVerLow, 0, '')
  new ImageDlg(app, this.image, false, this.callBackOK, function () { self.app.activeOutilCapt() })
}

OutilImageLibre.prototype.callBackOK = function (natImage, dataBase64) {
  // Quand on arrive ici, this pointer sur une boîte de dialogue ImageDlg
  var app = this.app
  var im = this.image
  im.natImage = natImage
  var tab = dataBase64.split(',')
  im.image = kernel.base64Decode(tab[tab.length - 1], true)
  var image = kernel.ce('img', {
    src: dataBase64
  })
  image.onload = function () {
    im.width = image.width
    im.height = image.height
    app.ajouteElement(im)
    im.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    app.outilActif.saveFig()
    app.activeOutilCapt()
  }
}
