/*
 * Created by yvesb on 12/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const OutilObjetPar1Objet = require('../outils/OutilObjetPar1Objet')
const NatObj = require('../types/NatObj')
const CImage = require('../objets/CImage')
const ImageDlg = require('../dialogs/ImageDlg')
const StyleEncadrement = require('../types/StyleEncadrement')
const CAffLiePt = require('../objets/CAffLiePt')
module.exports = OutilImageLiee
/**
 * Outil servant à créer une image libre sur la figure
 * @param app L'application  propriétaire
 * @constructor
 */
function OutilImageLiee (app) {
  OutilObjetPar1Objet.call(this, app, 'ImageLiee', 33099, true, NatObj.NTtPoint)
}

OutilImageLiee.prototype = new OutilObjetPar1Objet()

OutilImageLiee.prototype.indication = function () {
  return 'indPt'
}

OutilImageLiee.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  var self = this
  this.image = new CImage(app.listePr, null, false, app.getCouleur(), 0, 0, 0, 0, false, elg, 13,
    StyleEncadrement.Sans, false, app.doc.couleurFond, CAffLiePt.alignHorCent,
    CAffLiePt.alignVerLow, 0, '')
  new ImageDlg(app, this.image, false, this.callBackOK, function () { self.app.activeOutilCapt() })
}

OutilImageLiee.prototype.ajouteObjetsVisuels = function () {}

OutilImageLiee.prototype.callBackOK = function (natImage, dataBase64) {
  // Quand on arrive ici, this pointer sur une boîte de dialogue ImageDlg
  var app = this.app
  var im = this.image
  im.natImage = natImage
  var tab = dataBase64.split(',')
  im.image = kernel.base64Decode(tab[tab.length - 1], true)
  var image = kernel.ce('img', {
    src: dataBase64
  })
  image.onload = function () {
    im.width = image.width
    im.height = image.height
    app.ajouteElement(im)
    im.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    app.outilActif.saveFig()
    app.activeOutilCapt()
  }
}
