/*
 * Created by yvesb on 23/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CIntegrale = require('../objets/CIntegrale')
const NatCal = require('../types/NatCal')
const CValeur = require('../objets/CValeur')
const IntegraleDlg = require('../dialogs/IntegraleDlg')

module.exports = OutilInteg

function OutilInteg (app) {
  Outil.call(this, app, 'Integ', 33008)
}
OutilInteg.prototype = new Outil()

OutilInteg.prototype.select = function () {
  Outil.prototype.select.call(this)
  var list = this.app.listePr
  var integ = new CIntegrale(list, null, false, '', null, new CValeur(list, 0), new CValeur(list, 0), new CValeur(list, 0))
  new IntegraleDlg(this.app, integ, false, null, null)
  this.app.activeOutilCapt()
}

OutilInteg.prototype.activationValide = function () {
  var list = this.app.listePr
  return (list.nombreObjetsCalcul(NatCal.NCalcouFoncParFormule) >= 2)
}
