/*
 * Created by yvesb on 14/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const kernel = require('../kernel/kernel')
const CLatex = require('../objets/CLatex')
const CCommentaire = require('../objets/CCommentaire')
const LatexDlg = require('../dialogs/LatexDlg')
const AvertDlg = require('../dialogs/AvertDlg')
const CAffLiePt = require('../objets/CAffLiePt')
const Color = require('../types/Color')
const StyleEncadrement = require('../types/StyleEncadrement')
module.exports = OutilLatex
/**
 * Outil servant à créer un affichage de valeur libre sur la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilLatex (app) {
  Outil.call(this, app, 'Latex', 32010, true)
}
OutilLatex.prototype = new Outil()

OutilLatex.prototype.select = function () {
  var app = this.app
  Outil.prototype.select.call(this)
  app.outilPointageActif = this.app.outilPointageClic
  app.outilPointageActif.reset()
  app.indication('indEndroitAff')
}

OutilLatex.prototype.traiteObjetDesigne = function (elg, point) {
  var app = this.app
  var list = app.listePr
  this.comClig = new CCommentaire(list, null, false, Color.black, point.x, point.y, 0, 0, false, null, 16, StyleEncadrement.Sans, false,
    app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, kernel.getStr('AffIci'))
  this.comClig.positionne(false, app.dimf)
  this.comClig.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
  this.ajouteClignotementDe(this.comClig)
  this.resetClignotement()
  var self = this
  this.latex = new CLatex(list, null, false, app.getCouleur(), point.x, point.y, 0, 0, false, null, 16, StyleEncadrement.Sans,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft, CAffLiePt.alignVerTop, '')
  new LatexDlg(app, this.latex, false, function () { self.callBackOK() }, function () { self.callBackCancel() })
}

OutilLatex.prototype.callBackOK = function () {
  const app = this.app
  const self = this
  app.ajouteElement(this.latex)
  var verif = app.verifieDernierElement(1)
  if (verif) {
    // L'élément créé existe bien et a été ajouté à la liste
    this.latex.setReady4MathJax()
    MathJax.Hub.Queue(function () {
      self.latex.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    })
    this.annuleClignotement()
    this.saveFig()
  } else new AvertDlg(app, 'DejaCree')
  app.activeOutilCapt()
}

OutilLatex.prototype.callBackCancel = function () {
  this.app.activeOutilCapt()
}
