/*
 * Created by yvesb on 06/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const OutilLieuParVariableAncetre = require('./OutilLieuParVariableAncetre')
const CLieuDiscretParVariable = require('../objets/CLieuDiscretParVariable')
const LieuDlg = require('../dialogs/LieuDlg')
module.exports = OutilLieuDiscretParVariable

/**
 * Outil servant à créer un lieu de points discret généré par une variable
 * @param app L'application propriétaire
 * @constructor
 */

function OutilLieuDiscretParVariable (app) {
  OutilLieuParVariableAncetre.call(this, app, 'LieuDiscretParVariable', 33005)
}

OutilLieuDiscretParVariable.prototype = new OutilLieuParVariableAncetre()

OutilLieuDiscretParVariable.prototype.creeObjet = function () {
  var app = this.app
  var list = app.listePr
  var self = this
  this.lieu = new CLieuDiscretParVariable(list, null, false, app.getCouleur(), false, this.pointPourTrace, 200,
    app.getStylePoint(), this.va)
  new LieuDlg(app, this.lieu, false, function () { self.actionApresDlgOK() }, function () { self.app.activeOutilCapt() })
}
