/*
 * Created by yvesb on 06/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const OutilLieuParVariableAncetre = require('./OutilLieuParVariableAncetre')
const CLieuParVariable = require('../objets/CLieuParVariable')
const InfoLieu = require('../types/InfoLieu')
const LieuDlg = require('../dialogs/LieuDlg')
module.exports = OutilLieuParVariable

/**
 * Outil servant à créer un lieu de points reliés généré par un point lié
 * @param app L'application propriétaire
 * @constructor
 */

function OutilLieuParVariable (app) {
  OutilLieuParVariableAncetre.call(this, app, 'LieuParVariable', 32886)
}

OutilLieuParVariable.prototype = new OutilLieuParVariableAncetre()

OutilLieuParVariable.prototype.creeObjet = function () {
  var app = this.app
  var list = app.listePr
  var self = this
  this.lieu = new CLieuParVariable(list, null, false, app.getCouleur(), false, app.getStyleTrait(), this.pointPourTrace,
    new InfoLieu(200, false, false), this.va)
  new LieuDlg(app, this.lieu, false, function () { self.actionApresDlgOK() }, function () { self.app.activeOutilCapt() })
}
