/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const OutilMac = require('./OutilMac')
const CMacroAffectationValeurVariable = require('../objets/CMacroAffectationValeurVariable')
const MacAffValVarDlg = require('../dialogs/MacAffValVarDlg')
const CAffLiePt = require('../objets/CAffLiePt')
const CValeur = require('../objets/CValeur')
const NatCal = require('../types/NatCal')

module.exports = OutilMacAffValVar

/**
 * Outil servant à créer une macro affectant une valeur à une variable
 * @param app L'application propriétaire
 * @constructor
 */
function OutilMacAffValVar (app) {
  if (arguments.length === 0) return
  OutilMac.call(this, app, 'MacAnim', 32947)
}

OutilMacAffValVar.prototype = new OutilMac()

OutilMacAffValVar.prototype.traiteObjetDesigne = function (elg, point) {
  var self = this
  var app = this.app
  var list = app.listePr
  this.addComClign(point)
  this.mac = new CMacroAffectationValeurVariable(list, null, false, app.getCouleur(), point.x, point.y, 0, 0,
    false, null, 16, false, app.doc.couleurFond, CAffLiePt.alignHorLeft,
    CAffLiePt.alignVerTop, '', '', new CValeur(app.listePr, 0), null)
  new MacAffValVarDlg(app, this.mac, false,
    function () {
      self.creeObjet()
      app.activeOutilCapt()
    },
    function () {
      app.activeOutilCapt()
    })
}

OutilMacAffValVar.prototype.activationValide = function () {
  var list = this.app.listePr
  return (list.nombreObjetsCalcul(NatCal.NVariable) > 0)
}
