/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const OutilMac = require('./OutilMac')
const CMacroPause = require('../objets/CMacroPause')
const MacPauseDlg = require('../dialogs/MacPauseDlg')
const CAffLiePt = require('../objets/CAffLiePt')

module.exports = OutilMacPause

/**
 * Outil servant à créer une macro affectant une valeur à une variable
 * @param app L'application propriétaire
 * @constructor
 */
function OutilMacPause (app) {
  if (arguments.length === 0) return
  OutilMac.call(this, app, 'MacPause', 33027)
}

OutilMacPause.prototype = new OutilMac()

OutilMacPause.prototype.traiteObjetDesigne = function (elg, point) {
  var self = this
  var app = this.app
  var list = app.listePr
  this.addComClign(point)
  this.mac = new CMacroPause(list, null, false, app.getCouleur(), point.x, point.y, 0, 0, false, null, 16,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft,
    CAffLiePt.alignVerTop, '', '', 2)
  new MacPauseDlg(app, this.mac, false,
    function () {
      self.creeObjet()
      app.activeOutilCapt()
    },
    function () {
      app.activeOutilCapt()
    })
}
