/*
 * Created by yvesb on 27/09/2016.
 */

/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const CMarqueSegment = require('../objets/CMarqueSegment')
const OutilObjetPar1Objet = require('./OutilObjetPar1Objet')

module.exports = OutilMarqueSeg

/**
 * Outil servant à créer une marque de segemnt
 * @param app L'application propriétaire
 * @constructor
 */
function OutilMarqueSeg (app) {
  OutilObjetPar1Objet.call(this, app, 'MarqueSeg', 33091, true, NatObj.NSegment)
}

OutilMarqueSeg.prototype = new OutilObjetPar1Objet()

OutilMarqueSeg.prototype.indication = function () {
  return 'indSeg'
}

OutilMarqueSeg.prototype.objet = function (seg) {
  var app = this.app
  return new CMarqueSegment(app.listePr, null, false, app.getCouleur(), false, app.getStyleTrait(),
    app.getStyleMarqueSegment(), seg)
}

// Pas d'objets visuels pour cet outil
OutilMarqueSeg.prototype.ajouteObjetsVisuels = function () {
}

OutilMarqueSeg.prototype.isReadyForTouchEnd = function () {
  return false
}
