/*
 * Created by yvesb on 11/02/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const NatObj = require('../types/NatObj')
const Outil = require('./Outil')
const AvertDlg = require('../dialogs/AvertDlg')
module.exports = OutilMarquerPt
/**
 * Outil servant à marquer un point pour la trace
 * @param app L'application propriétaire
 * @constructor
 */
function OutilMarquerPt (app) {
  Outil.call(this, app, 'MarquerPt', 32029, true)
}

OutilMarquerPt.prototype = new Outil()

OutilMarquerPt.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  this.obj = null
  app.outilPointageActif = app.outilPointageObjetClignotant
  app.outilPointageActif.aDesigner = NatObj.NTtPoint
  // On fait clignoter les points mobiles libres
  app.listeClignotante.ajoutePointsMarquesPourTrace(app.listePr, false)
  app.outilPointageActif.reset(false, true) // Deuxième paramètre true pour pouvoir désigné un objet clignotant
  // même lorsqu'il est phase de masquage
  this.resetClignotement()
  app.indication('indMarq')
}

OutilMarquerPt.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  elg.marquePourTrace = true
  new AvertDlg(app, 'PtMarque')
  this.enleveDeClign(elg)
  this.saveFig()
}
