/*
 * Created by yvesb on 07/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const kernel = require('../kernel/kernel')
const CalcR = require('../kernel/CalcR')
const CMatriceParForm = require('../objets/CMatriceParForm').default
const MatriceParFormDlg = require('../dialogs/MatriceParFormDlg')

module.exports = OutilMatriceParForm

function OutilMatriceParForm (app) {
  Outil.call(this, app, 'MatriceParForm', 32049)
}

OutilMatriceParForm.prototype = new Outil()

OutilMatriceParForm.prototype.select = function () {
  const app = this.app
  Outil.prototype.select.call(this)
  const list = this.app.listePr
  const form = kernel.getStr('formMat')
  const mat = new CMatriceParForm(list, null, false, '', 3, 3,
    CalcR.ccb(form, list, 0, form.length - 1, ['i', 'j'], list))
  new MatriceParFormDlg(app, mat, false, function () { app.activeOutilCapt() }, function () { app.activeOutilCapt() })
}
