/*
 * Created by yvesb on 27/09/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Color = require('../types/Color')
const StyleMarqueSegment = require('../types/StyleMarqueSegment')
const StyleTrait = require('../types/StyleTrait')
const CMarqueSegment = require('../objets/CMarqueSegment')
const CMilieu = require('../objets/CMilieu')
const CSegment = require('../objets/CSegment')
const OutilObjetPar2Pts = require('./OutilObjetPar2Pts')
module.exports = OutilMilieu
/**
 * Outil servant à créer une droite définie par deux points
 * @param app L'application propriétaire
 * @constructor
 */
function OutilMilieu (app) {
  OutilObjetPar2Pts.call(this, app, 'Milieu', 32781, true)
}

OutilMilieu.prototype = new OutilObjetPar2Pts()

OutilMilieu.prototype.preIndication = function () {
  return 'Milieu'
}

OutilMilieu.prototype.objet = function (pt1, pt2) {
  var app = this.app
  return new CMilieu(app.listePr, null, false, app.getCouleur(), false, 0, 3, false, '', app.getTaillePoliceNom(),
    app.getStylePoint(), false, pt1, pt2)
}

OutilMilieu.prototype.ajouteObjetsVisuels = function () {
  var app = this.app
  var list = app.listeObjetsVisuels
  var b = Color.black
  var stfp = StyleTrait.stfp(list)
  var stfc = StyleTrait.stfc2(list)
  var mms = StyleMarqueSegment.marqueSimple
  var mil = this.objet(this.point1, app.mousePoint)
  app.ajouteObjetVisuel(mil)
  var seg1 = new CSegment(list, null, false, b, false, stfp, this.point1, mil)
  app.ajouteObjetVisuel(seg1)
  var seg2 = new CSegment(list, null, false, b, false, stfp, mil, app.mousePoint)
  app.ajouteObjetVisuel(seg2)
  var ms1 = new CMarqueSegment(list, null, false, b, false, stfc, mms, seg1)
  app.ajouteObjetVisuel(ms1)
  var ms2 = new CMarqueSegment(list, null, false, b, false, stfc, mms, seg2)
  app.ajouteObjetVisuel(ms2)
  app.afficheObjetVisuels(0) // Ajout version 6.4.4
}
