/*
 * Created by yvesb on 16/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const NatObj = require('../types/NatObj')
module.exports = OutilModifObjGraph

/**
 * Outil servant à modifier un objet qui a été créé par un menu
 * @param app L'application propriétaire
 * @constructor
 */
function OutilModifObjGraph (app) {
  Outil.call(this, app, 'ModifObjGraph', 35000, true)
}

OutilModifObjGraph.prototype = new Outil()

OutilModifObjGraph.prototype.select = function () {
  var app = this.app
  Outil.prototype.select.call(this)
  app.outilPointageActif = app.outilPointageCre
  app.outilPointageCre.aDesigner = NatObj.NTtObj
  if (app.estExercice) {
    for (var i = 0; i < app.nbObjInit; i++) {
      var el = app.listePr.get(i)
      if (el.estDeNature(NatObj.NTtObj) && el.modifiableParMenu()) this.excluDeDesignation(el)
    }
  }
  app.outilPointageCre.reset(true) // true pour ne pouvoir modifier que les objets modifiables par menu
}

OutilModifObjGraph.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  var self = this
  this.ajouteClignotementDe(elg)
  var ant = elg.antecedentDirect()
  if (ant.estDeNature(NatObj.NTransformation)) {
    ant.modificationImage(app, elg, true)
  } else {
    elg.modifDlg(app, function () { // La fonction utilisée quand l'utilisateur valide la boîte de dialogue
      var list = app.listePr
      list.initialiseDependances()
      // list.positionneDependantsDe(false, app.dimf, elg) // Modifié version 6.4.1
      list.positionneDependantsDe(false, app.dimf, elg, true) // full à true pour un positionneFull
      list.updateDependants(elg, app.svgFigure, app.doc.couleurFond, app.doc.opacity, true)
    }, function () {
      self.reselect()
    })
  }
}
