/*
 * Created by yvesb on 02/02/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const Outil = require('./Outil')
const EntreeNomDlg = require('../dialogs/EntreeNomDlg')
module.exports = OutilNommer
/**
 * Outil servant à créer une droite horizontale
 * @param app L'application propriétaire
 * @constructor
 */
function OutilNommer (app) {
  Outil.call(this, app, 'Nommer', -1, true, true, true)
}

OutilNommer.prototype = new Outil()

OutilNommer.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  this.obj = null
  app.outilPointageActif = app.outilPointageCre
  /// //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //      Dans un exercice de construction, on ne permet pas de nommer les objets pournis pour la construction      //
  /// //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  var list = app.listePr
  if (app.estExercice) {
    for (var i = 0; i < app.nbObjInit; i++) {
      var el = list.get(i)
      if (el.estDeNature(NatObj.NObjNommable)) this.excluDeDesignation(el)
    }
  }
  // On ne permet pas de nommer une droite clone
  for (i = 0; i < list.longueur(); i++) {
    el = list.get(i)
    if (el.className === 'CDroiteClone') this.excluDeDesignation(el)
  }
  /// ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  app.outilPointageCre.aDesigner = NatObj.NObjNommable
  app.outilPointageCre.reset()
  app.indication('indPtOuDte')
}

OutilNommer.prototype.deselect = function () {
  this.obj = null
  Outil.prototype.deselect.call(this)
}

OutilNommer.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  // if (app.lastDlgId() === "nomDlg") return;
  this.obj = elg
  this.ajouteClignotementDe(this.obj)
  this.resetClignotement()
  new EntreeNomDlg(app, this.obj)
}
