/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const OptionsFigDlg = require('../dialogs/OptionsFigDlg')
module.exports = OutilOptionsFig

function OutilOptionsFig (app) {
  Outil.call(this, app, 'OptionsFig', -1, false, false) // Le dernier false car l'outil n'est pas sélectionnable
}

OutilOptionsFig.prototype = new Outil()

OutilOptionsFig.prototype.select = function () {
  var self = this
  new OptionsFigDlg(this.app, function () { self.callBackOK() })
}

OutilOptionsFig.prototype.callBackOK = function () {
  var app = this.app
  var list = app.listePr
  list.positionne(false, app.dimf)
  list.update(app.svgFigure, app.doc.couleurFond, app.doc.opacity, true)
  this.saveFig()
  app.updateToolsToolBar() // Si par exemple on a changé l'unité d'angle certains outils
  // peuvent être devenus actis ou inactifs
}
