/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CPointBase = require('../objets/CPointBase')
module.exports = OutilPtLib
/**
 * Outil servant à créer un point libre sur la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilPtLib (app) {
  Outil.call(this, app, 'PtLib', 32779, false)
}
OutilPtLib.prototype = new Outil()

OutilPtLib.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  app.outilPointageActif = this.app.outilPointageClic
  app.outilPointageActif.reset()
  app.indication('indPtLib')
}

OutilPtLib.prototype.traiteObjetDesigne = function (elg, point) {
  var app = this.app
  var pt = new CPointBase(this.app.doc.listePr, null, false, this.app.getCouleur(), false,
    0, 3, false, '', app.getTaillePoliceNom(), this.app.getStylePoint(), false, true, point.x, point.y)
  this.app.ajouteElement(pt)
  pt.creeAffichage(this.app.svgFigure, false, this.app.doc.couleurFond, this.app.doc.opacity)
  this.saveFig()
}
