/*
 * Created by yvesb on 27/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatCal = require('../types/NatCal')
const Outil = require('../outils/Outil')
const CPointDansRepere = require('../objets/CPointDansRepere')
const CValeur = require('../objets/CValeur')
const PtParCoordDlg = require('../dialogs/PtParCoordDlg')
const AvertDlg = require('../dialogs/AvertDlg')

module.exports = OutilPtParCoord
/**
 * Outil servant à créer l'image d'un objet par une rotation
 * @param app L'application propriétaire
 * @constructor
 */
function OutilPtParCoord (app) {
  Outil.call(this, app, 'PtParCoord', 32782, false) // fakse car pas de clignotement
}

OutilPtParCoord.prototype = new Outil()

OutilPtParCoord.prototype.activationValide = function () {
  return this.app.listePr.nombreObjetsCalcul(NatCal.NRepere) > 0
}

OutilPtParCoord.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  var li = app.listePr
  var abs = new CValeur(li, 1)
  var ord = new CValeur(li, 1)
  this.point = new CPointDansRepere(li, null, false, app.getCouleur(), false, 0, 3, false, '', app.getTaillePoliceNom(),
    app.getStylePoint(), false, li.premierRepVis(), abs, ord)
  var self = this
  new PtParCoordDlg(app, this.point, false, function () { self.actionApresDlgOK() }, function () { self.app.activeOutilCapt() })
  app.activeOutilCapt()
}

OutilPtParCoord.prototype.actionApresDlgOK = function () {
  var app = this.app
  app.ajouteElement(this.point)
  if (app.verifieDernierElement(1)) {
    // Le point créé existe bien et n'a pas été déjà créé
    this.point.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    // this.annuleClignotement(); // Pour que le centre clignotant ne soit pas enregistré comme caché
    this.saveFig()
  } else new AvertDlg(app, 'DejaCree')
  app.activeOutilCapt() // Après création on revient à l'outil de capture
}
