/*
 * Created by yvesb on 15/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const RenommerCalculDlg = require('../dialogs/RenommerCalculDlg')
const NatCal = require('../types/NatCalAdd')
module.exports = OutilRenommerCalcul

/**
 * Outil servant à renommer un calcul
 * @param app L'application propriétaire
 * @constructor
 */
function OutilRenommerCalcul (app) {
  Outil.call(this, app, 'RenommerCalcul', 33158)
}

OutilRenommerCalcul.prototype = new Outil()

OutilRenommerCalcul.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  new RenommerCalculDlg(app, function () { app.activeOutilCapt() }, function () { app.activeOutilCapt() })
}

OutilRenommerCalcul.prototype.activationValide = function () {
  return this.app.listePr.nombreObjetsCalcul(NatCal.NTtCalcNommeSaufConst) > 0
}
