/*
 * Created by yvesb on 27/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('../outils/Outil')
const NatObj = require('../types/NatObj')
const SegmentParLongDlg = require('../dialogs/SegmentParLongDlg')
module.exports = OutilSegmentParLong

/**
 * Outil servant à transformer un point libre en un point lié à u  objet
 * @param app L'application propriétaire
 * @constructor
 */
function OutilSegmentParLong (app) {
  Outil.call(this, app, 'SegmentParLong', 32040, true)
}

OutilSegmentParLong.prototype = new Outil()

OutilSegmentParLong.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  this.point = null // Pointera sur l'extrémité gauche ou haute du curseur
  app.outilPointageActif = app.outilPointageClicOuPt
  app.outilPointageActif.aDesigner = NatObj.NTtPoint
  app.outilPointageActif.reset()
  this.resetClignotement()
  app.indication('indCurseur1')
}

OutilSegmentParLong.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  new SegmentParLongDlg(app, elg, app.outilPointageClicOuPt.bptCree)
}

OutilSegmentParLong.prototype.activationValide = function () {
  return this.app.listePr.pointeurLongueurUnite !== null
}
