/*
 * Created by yvesb on 15/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CSuiteRec = require('../objets/CSuiteRec')
const SuiteRecDlg = require('../dialogs/SuiteRecDlg')
const CValeur = require('../objets/CValeur')
const NatCal = require('../types/NatCal')

module.exports = OutilSuiteRec

function OutilSuiteRec (app) {
  Outil.call(this, app, 'SuiteRec', 32881)
}
OutilSuiteRec.prototype = new Outil()

OutilSuiteRec.prototype.select = function () {
  Outil.prototype.select.call(this)
  var self = this
  var list = this.app.listePr
  var suite = new CSuiteRec(list, null, false, '', null, new CValeur(list, 0), new CValeur(list, 0))
  new SuiteRecDlg(this.app, suite, 1, true, false, function () { self.app.activeOutilCapt() }, null)
  this.app.activeOutilCapt()
}

OutilSuiteRec.prototype.activationValide = function () {
  var list = this.app.listePr
  return list.nombreObjetsCalcul(NatCal.NFoncR1Var) > 0
}
