/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CSuiteRec2 = require('../objets/CSuiteRec2')
const SuiteRecDlg = require('../dialogs/SuiteRecDlg')
const CValeur = require('../objets/CValeur')
const NatCal = require('../types/NatCal')

module.exports = OutilSuiteRec2

function OutilSuiteRec2 (app) {
  Outil.call(this, app, 'SuiteRec2', 32043)
}
OutilSuiteRec2.prototype = new Outil()

OutilSuiteRec2.prototype.select = function () {
  Outil.prototype.select.call(this)
  var self = this
  var list = this.app.listePr
  var suite = new CSuiteRec2(list, null, false, '', null, new CValeur(list, 0), new CValeur(list, 0))
  new SuiteRecDlg(this.app, suite, 2, true, false, function () { self.app.activeOutilCapt() }, null)
  this.app.activeOutilCapt()
}

OutilSuiteRec2.prototype.activationValide = function () {
  var list = this.app.listePr
  return list.nombreObjetsCalcul(NatCal.NFonction2Var) > 0
}
