/*
 * Created by yvesb on 15/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CSuiteRecComplexe = require('../objets/CSuiteRecComplexe')
const SuiteRecDlg = require('../dialogs/SuiteRecDlg')
const CValeur = require('../objets/CValeur')
const CValeurComp = require('../objets/CValeurComp')
const NatCal = require('../types/NatCal')

module.exports = OutilSuiteRecComplexe

function OutilSuiteRecComplexe (app) {
  Outil.call(this, app, 'SuiteRecComplexe', 33138)
}
OutilSuiteRecComplexe.prototype = new Outil()

OutilSuiteRecComplexe.prototype.select = function () {
  Outil.prototype.select.call(this)
  var self = this
  var list = this.app.listePr
  var suite = new CSuiteRecComplexe(list, null, false, '', null, new CValeur(list, 0), new CValeurComp(list))
  new SuiteRecDlg(this.app, suite, 1, false, false, function () { self.app.activeOutilCapt() }, null)
  this.app.activeOutilCapt()
}

OutilSuiteRecComplexe.prototype.activationValide = function () {
  var list = this.app.listePr
  return list.nombreObjetsCalcul(NatCal.NFonctionComplexe) > 0
}
