/*
 * Created by yvesb on 15/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CSuiteRecComplexe2 = require('../objets/CSuiteRecComplexe2')
const SuiteRecDlg = require('../dialogs/SuiteRecDlg')
const CValeur = require('../objets/CValeur')
const CValeurComp = require('../objets/CValeurComp')
const NatCal = require('../types/NatCal')

module.exports = OutilSuiteRecComplexe2

function OutilSuiteRecComplexe2 (app) {
  Outil.call(this, app, 'SuiteRecComplexe2', 32042)
}
OutilSuiteRecComplexe2.prototype = new Outil()

OutilSuiteRecComplexe2.prototype.select = function () {
  Outil.prototype.select.call(this)
  var self = this
  var list = this.app.listePr
  var suite = new CSuiteRecComplexe2(list, null, false, '', null, new CValeur(list, 0), new CValeurComp(list))
  new SuiteRecDlg(this.app, suite, 2, false, false, function () { self.app.activeOutilCapt() }, null)
  this.app.activeOutilCapt()
}

OutilSuiteRecComplexe2.prototype.activationValide = function () {
  var list = this.app.listePr
  return list.nombreObjetsCalcul(NatCal.NFonctionComplexe2Var) > 0
}
