/*
 * Created by yvesb on 18/01/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const CSurfaceLieuDeuxPoints = require('../objets/CSurfaceLieuDeuxPoints')
const OutilObjetPar3Objets = require('./OutilObjetPar3Objets')

module.exports = OutilSurfaceLieu2Pts

/**
 * Outil servant à créer une surface délimitée par un polygône, un cercle, un arc de cercle ou un lieu fermé
 * @param app L'application propriétaire
 * @constructor
 */
function OutilSurfaceLieu2Pts (app) {
  OutilObjetPar3Objets.call(this, app, 'SurfaceLieu2Pts', 32872, true, NatObj.NLieu, NatObj.NTtPoint, NatObj.NTtPoint)
}

OutilSurfaceLieu2Pts.prototype = new OutilObjetPar3Objets()

OutilSurfaceLieu2Pts.prototype.indication = function (ind) {
  switch (ind) {
    case 1 : return 'indSurfLieuDte1'
    case 2 : return 'indSurfLieu2pts2'
    case 3 : return 'indSurfLieu2pts3'
  }
}

OutilSurfaceLieu2Pts.prototype.objet = function (ob1, ob2, ob3) {
  var app = this.app
  return new CSurfaceLieuDeuxPoints(app.listePr, null, false, app.getCouleur(), false, app.getStyleRemplissage(),
    ob1, ob2, ob3)
}
