/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
module.exports = OutilTaillePlus

/**
 * Outil servant à zoomer sur la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilTaillePlus (app) {
  Outil.call(this, app, 'TaillePlus', -1, false, false) // Le dernier false car l'outil n'est pas sélectionnable
}

OutilTaillePlus.prototype = new Outil()

OutilTaillePlus.prototype.select = function () {
  var app = this.app
  var list = app.listePr
  var svg = app.svgFigure
  var done = list.taillePlus(svg)
  if (done) {
    list.positionne(false, app.dimf)
    list.updateDisplays(svg, app.doc.couleurFond, app.doc.opacity, true)
    app.gestionnaire.enregistreFigureEnCours()
  }
}
