/*
 * Created by yvesb on 18/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const constantes = require('../kernel/constantes')
module.exports = OutilZoomPlus

/**
 * Outil servant à zoomer sur la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilZoomPlus (app) {
  Outil.call(this, app, 'ZoomPlus', 32905, false, false) // Le dernier false car l'outil n'est pas sélectionnable
}

OutilZoomPlus.prototype = new Outil()

OutilZoomPlus.prototype.select = function () {
  var x, y
  var app = this.app
  var list = app.listePr
  var dimf = app.dimf
  var rep = list.premierRepVis()
  x = rep !== null ? rep.o.x : dimf.x / 2
  y = rep !== null ? rep.o.y : dimf.y / 2
  list.zoom(x, y, constantes.rapportZoomPlus)
  list.positionne(false, dimf)
  list.update(app.svgFigure, app.doc.couleurFond, app.doc.opacity, true)
  app.gestionnaire.enregistreFigureEnCoursPourZoom()
}
