/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const OutilCodeTikz = require('../outils/OutilCodeTikz')
const AvertDlg = require('../dialogs/AvertDlg')
const kernel = require('../kernel/kernel')
const CodeTikzDlg = require('../dialogs/CodeTikzDlg')
module.exports = OutilCodeTikz

OutilCodeTikz.prototype.select = function () {
  // Ici il faut appeler une fontion de callBack pour que savePNG ne soit appelé que lorsque les données
  // sont prêtes.
  // copyTikz est une fonction globale de la page index.html pour la version electron
  var app = this.app
  new CodeTikzDlg(app, function (code) {
    copyTikz(code) // eslint-disable-line no-undef
    new AvertDlg(app, kernel.getStr('CodeOK'))
  })
}
