/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('../outils/Outil')
const SavePNGWithUnityDlg = require('../dialogs/SavePNGWithUnityDlg')
module.exports = OutilCopyWithUnity
/**
 * Outil servant à modifier un objet qui a été créé par un menu
 * @param app L'application propriétaire
 * @constructor
 */
function OutilCopyWithUnity (app) {
  Outil.call(this, app, '', 'Copy', -1, false, false) // Le dernier false car l'outil n'est pas sélectionnable
}

OutilCopyWithUnity.prototype = new Outil()

OutilCopyWithUnity.prototype.select = function () {
  // Ici il faut appeler une fontion de callBack pour que copy ne soit appelé que lorsque les données
  // sont prêtes.
  // savePNG est une fonction globale de la page index.html pour la version electron
  new SavePNGWithUnityDlg(this.app, false)
}

OutilCopyWithUnity.prototype.activationValide = function () {
  return this.app.listePr.pointeurLongueurUnite !== null
}
