/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

// Ce fichier est utilisé quand l'appli Web ne tourne pas sous electron
const OutilOpen = require('../outils/OutilOpen')
const ConfirmDlg = require('../dialogs/ConfirmDlg')
module.exports = OutilOpen

OutilOpen.prototype.select = function () {
  var app = this.app
  // Pour cet outil ne pas appeler Outil.prototype.select
  // Ajout version 6.4. Il faut arrêter toute macro en cours d'exécution
  app.termineMacroEnCours()
  app.activeOutilCapt() // Ajout version 6.4.1 pour éviter plantages si par ex l'outil rideau est actiF
  //
  if (app.doc.isDirty) {
    new ConfirmDlg(app, 'AvertDirty', function () {
      openFile() // eslint-disable-line no-undef
    })
  } else openFile() // eslint-disable-line no-undef
  // open est une fonction globale de la page index.html pour la version electron
}
