/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const OutilCodeBase64 = require('../outils/OutilCodeBase64')
const DisplayCodeDlg = require('../dialogs/DisplayCodeDlg')
const Dimf = require('../types/Dimf')
module.exports = OutilCodeBase64

OutilCodeBase64.prototype.select = function () {
  var app = this.app
  var doc = app.doc
  var olddimf = doc.dimf
  if (app.cadre !== null) { doc.dimf = new Dimf(app.widthCadre, app.heightCadre) }
  var code = app.getBase64Code()
  doc.dimf = olddimf
  new DisplayCodeDlg(app, code, 'Base64')
}
