/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
/**
 * @typedef TikzColor
 * @type {object}
 */
const TikzColor = {
  colorString: function (col) {
    var r = col.getRed()
    var g = col.getGreen()
    var b = col.getBlue()
    var rs = r.toString(16)
    if (rs.length === 1) rs = '0' + rs
    var gs = g.toString(16)
    if (gs.length === 1) gs = '0' + gs
    var bs = b.toString(16)
    if (bs.length === 1) bs = '0' + bs

    var ch = rs + gs + bs
    var ch2 = ''
    for (var i = 0; i < 6; i++) {
      var car = ch.charAt(i)
      // var code = (int)car;
      var code = car.charCodeAt(0)
      if ((code >= 48) && (code <= 57)) code += 56
      ch2 += String.fromCharCode(code)
    }
    return ch2
  },
  containsColor: function (vect, col) {
    for (var i = 0; i < vect.length; i++) {
      if (vect[i] === TikzColor.colorString(col)) return true
    }
    return false
  }
}

module.exports = TikzColor
